//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//
// ControlDialogBar.cpp : implementation file
//

#include "stdafx.h"
#include "MPlayerX.h"
#include "ControlDialogBar.h"
#include "MainFrm.h"
#include "delaytransformfilter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CControlDialogBar

CControlDialogBar::CControlDialogBar()
{
}

CControlDialogBar::~CControlDialogBar()
{
}


BEGIN_MESSAGE_MAP(CControlDialogBar, CSizingControlBarG)
	//{{AFX_MSG_MAP(CControlDialogBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CControlDialogBar message handlers

int CControlDialogBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CSizingControlBarG::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if(!m_wndSliderCtrlVolume.Create(WS_CHILD | WS_VISIBLE | TBS_HORZ | TBS_AUTOTICKS | TBS_TOP,
			CRect(0, 0, 0, 0), this, IDC_SLIDER_VOLUME))
		return -1;

	if(!m_wndSliderCtrlBalance.Create(WS_CHILD | WS_VISIBLE | TBS_HORZ | TBS_AUTOTICKS | TBS_TOP,
			CRect(0, 0, 0, 0), this, IDC_SLIDER_BALANCE))
		return -1;

	if(!m_wndSliderCtrlSpeed.Create(WS_CHILD | WS_VISIBLE | TBS_HORZ | TBS_AUTOTICKS | TBS_TOP,
			CRect(0, 0, 0, 0), this, IDC_SLIDER_SPEED))
		return -1;

	if(!m_wndSliderCtrlDelay.Create(WS_CHILD | WS_VISIBLE | TBS_HORZ | TBS_AUTOTICKS | TBS_TOP,
			CRect(0, 0, 0, 0), this, IDC_SLIDER_DELAY))
		return -1;

	CString szText;
	szText.LoadString(IDS_DIALOGBAR_CONTROL_VOLUME);
	if(!m_wndStaticVolume.Create(szText, WS_CHILD | WS_VISIBLE,
			CRect(0, 0, 0, 0), this))
		return -1;

	szText.LoadString(IDS_DIALOGBAR_CONTROL_BALANCE);
	if(!m_wndStaticBalance.Create(szText, WS_CHILD | WS_VISIBLE,
			CRect(0, 0, 0, 0), this))
		return -1;

	szText.LoadString(IDS_DIALOGBAR_CONTROL_SPEED);
	if(!m_wndStaticSpeed.Create(szText, WS_CHILD | WS_VISIBLE,
			CRect(0, 0, 0, 0), this))
		return -1;

	szText.LoadString(IDS_DIALOGBAR_CONTROL_DELAY);
	if(!m_wndStaticDelay.Create(szText, WS_CHILD | WS_VISIBLE,
			CRect(0, 0, 0, 0), this))
		return -1;

	m_wndStaticVolume.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));
	m_wndStaticBalance.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));
	m_wndStaticSpeed.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));
	m_wndStaticDelay.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));

	m_wndSliderCtrlVolume.SetTicFreq(1000);
	m_wndSliderCtrlVolume.SetRange(-10000, 0);
	m_wndSliderCtrlVolume.SetPos(0);

	m_wndSliderCtrlBalance.SetTicFreq(2000);
	m_wndSliderCtrlBalance.SetRange(-10000, 10000);
	m_wndSliderCtrlBalance.SetPos(0);

	m_wndSliderCtrlSpeed.SetTicFreq(10);
	m_wndSliderCtrlSpeed.SetRange(-80, 80);
	m_wndSliderCtrlSpeed.SetPos(10);

	m_wndSliderCtrlDelay.SetTicFreq(100);
	m_wndSliderCtrlDelay.SetRange(-1000, 1000);
	m_wndSliderCtrlDelay.SetPos(0);

	return 0;
}

void CControlDialogBar::OnSize(UINT nType, int cx, int cy) 
{
	CSizingControlBarG::OnSize(nType, cx, cy);
	
	m_wndStaticVolume.MoveWindow(5, 0, cx, 15);
	m_wndSliderCtrlVolume.MoveWindow(5, 15, cx - 5, 30);

	m_wndStaticBalance.MoveWindow(5, 45, cx, 15);
	m_wndSliderCtrlBalance.MoveWindow(5, 60, cx - 5, 30);

	m_wndStaticSpeed.MoveWindow(5, 90, cx, 15);
	m_wndSliderCtrlSpeed.MoveWindow(5, 105, cx - 5, 30);

	m_wndStaticDelay.MoveWindow(5, 135, cx, 15);
	m_wndSliderCtrlDelay.MoveWindow(5, 150, cx - 5, 30);
}

void CControlDialogBar::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CSliderCtrl * pSliderCtrl = (CSliderCtrl *)pScrollBar;
	if(pScrollBar)
	{
		if(pScrollBar->m_hWnd == m_wndSliderCtrlVolume.m_hWnd)
			UpdateVolume();
		if(pScrollBar->m_hWnd == m_wndSliderCtrlBalance.m_hWnd)
			UpdateBalance();
		if(pScrollBar->m_hWnd == m_wndSliderCtrlSpeed.m_hWnd)
			UpdateSpeed();
		if(pScrollBar->m_hWnd == m_wndSliderCtrlDelay.m_hWnd)
			UpdateDelay();
	}

	CSizingControlBarG::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CControlDialogBar::UpdateVolume()
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		long nValue = m_wndSliderCtrlVolume.GetPos();
		//CString szText;
		//szText.Format(IDS_STRING_VOLUME, nValue);
		CString szText, szText1;
		szText1.LoadString(IDS_STRING_VOLUME);
		szText.Format(szText1, nValue);
		m_wndStaticVolume.SetWindowText(szText);
		if(pMainFrame->m_pBasicAudio)
			pMainFrame->m_pBasicAudio->put_Volume(nValue);
		pMainFrame->m_SettingsCurrent.m_nSoundLevel = nValue;
		pMainFrame->m_SettingsCurrent.m_fSoundMute = FALSE;
	}
}

void CControlDialogBar::UpdateBalance()
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		long nValue = m_wndSliderCtrlBalance.GetPos();
		CString szText;
		szText.Format(IDS_STRING_BALANCE, nValue);
		m_wndStaticBalance.SetWindowText(szText);
		if(pMainFrame->m_pBasicAudio)
			pMainFrame->m_pBasicAudio->put_Balance(nValue);
		pMainFrame->m_SettingsCurrent.m_nSoundBalance = nValue;
	}
}

void CControlDialogBar::UpdateSpeed()
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		double rValue = (double)m_wndSliderCtrlSpeed.GetPos() / 10.0;
		CString szText;
		szText.Format(IDS_STRING_SPEED, rValue);
		m_wndStaticSpeed.SetWindowText(szText);
		if(pMainFrame->m_pMediaSeeking)
			pMainFrame->m_pMediaSeeking->SetRate(rValue);
	}
}

void CControlDialogBar::UpdateDelay()
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		long nValue = m_wndSliderCtrlDelay.GetPos() * 10;
		CString szText;
		szText.Format(IDS_STRING_DELAY, nValue);
		m_wndStaticDelay.SetWindowText(szText);
		if(pMainFrame->m_pDelayTransformFilter)
			pMainFrame->m_pDelayTransformFilter->m_nDelay = nValue;
		pMainFrame->m_nDelay = nValue;
	}
}
