//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "stdafx.h"
#include "delaytransformfilter.h"

CDelayTransformFilter::CDelayTransformFilter()
		: CTransInPlaceFilter (NAME("Delay filter"), NULL, GUID_NULL, &m_hr) //NULL)
{
	m_nDelay = 0;
}

HRESULT CDelayTransformFilter::Transform(IMediaSample *pSample)
{
	REFERENCE_TIME TimeStart, TimeEnd;
	if (NOERROR == pSample->GetTime(&TimeStart, &TimeEnd))
	{
		TimeStart += m_nDelay * 10000;
		TimeEnd += m_nDelay * 10000;
		pSample->SetTime(&TimeStart, &TimeEnd);
	}

	return NOERROR;
};

// We accept any input type.
HRESULT CDelayTransformFilter::CheckInputType(const CMediaType* mtIn)
{
    // just for example, we accept a common set of
    // video types
    if(*mtIn->Type() != MEDIATYPE_Video)
		return S_FALSE;

	if(*mtIn->FormatType() != FORMAT_VideoInfo && *mtIn->FormatType() != FORMAT_VideoInfo2)
		return S_FALSE;

    if(*mtIn->Subtype() != MEDIASUBTYPE_YUY2 && *mtIn->Subtype() != MEDIASUBTYPE_RGB565 && *mtIn->Subtype() != MEDIASUBTYPE_RGB24)
		return S_FALSE;

  	return S_OK;
}
