//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//
// FileBrowserDialogBar.cpp : implementation file
//

#include "stdafx.h"
#include "MPlayerX.h"
#include "MainFrm.h"
#include "FileBrowserDialogBar.h"
#include "NetExplorerDoc.h"
#include "MltiTree.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileBrowserDialogBar

CFileBrowserDialogBar::CFileBrowserDialogBar()
{
}

CFileBrowserDialogBar::~CFileBrowserDialogBar()
{
}

BEGIN_MESSAGE_MAP(CFileBrowserDialogBar, CSizingControlBarG)
	//{{AFX_MSG_MAP(CFileBrowserDialogBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CFileBrowserDialogBar message handlers

int CFileBrowserDialogBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if(CSizingControlBarG::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if(!m_LeftView.Create(NULL, "LeftView", WS_CHILD | WS_VISIBLE,
		CRect(0, 0, 0, 0), this, IDC_LISTCTRL_PLAY_LIST))
		return -1;

	return 0;
}

void CFileBrowserDialogBar::OnSize(UINT nType, int cx, int cy) 
{
	CSizingControlBarG::OnSize(nType, cx, cy);

	m_LeftView.MoveWindow(0, 0, cx, cy);
}

bool CFileBrowserDialogBar::SelectNextEntry()
{
	HTREEITEM hTreeItem = m_LeftView.m_pTree->GetFirstSelectedItem();
	if(hTreeItem != NULL)
	{
		while((hTreeItem = m_LeftView.m_pTree->GetNextSiblingItem(hTreeItem)) != NULL)
		{
			CTreeNode * pTreeNode = (CTreeNode *)m_LeftView.m_pTree->GetItemData(hTreeItem);
			if(pTreeNode != NULL && pTreeNode->nType == CTreeNode::File)
			{
				((CTreeCtrl*)(m_LeftView.m_pTree))->SelectItem(hTreeItem);
				return true;
			}
		}
	}
	return false;
}

bool CFileBrowserDialogBar::SelectPreviousEntry()
{
	HTREEITEM hTreeItem = m_LeftView.m_pTree->GetFirstSelectedItem();
	if(hTreeItem != NULL)
	{
		while((hTreeItem = m_LeftView.m_pTree->GetPrevSiblingItem(hTreeItem)) != NULL)
		{
			CTreeNode * pTreeNode = (CTreeNode *)m_LeftView.m_pTree->GetItemData(hTreeItem);
			if(pTreeNode != NULL && pTreeNode->nType == CTreeNode::File)
			{
				((CTreeCtrl*)(m_LeftView.m_pTree))->SelectItem(hTreeItem);
				return true;
			}
		}
	}
	return false;
}

CTreeNode * CFileBrowserDialogBar::GetCurrentSelection()
{
	HTREEITEM hTreeItem = m_LeftView.m_pTree->GetFirstSelectedItem();
	if(hTreeItem != NULL)
	{
		CTreeNode * pTreeNode = (CTreeNode *)m_LeftView.m_pTree->GetItemData(hTreeItem);
		if(pTreeNode != NULL && pTreeNode->nType == CTreeNode::File)
			return pTreeNode;
	}

	return NULL;
}

BOOL CFileBrowserDialogBar::PreTranslateMessage(MSG* pMsg)
{
    if (pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST)
		return FALSE;

	return CSizingControlBarG::PreTranslateMessage(pMsg);
}
