//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//
// MPlayerX.h : main header file for the MPLAYERX application
//

#if !defined(AFX_MPLAYERX_H__INCLUDED_)
#define AFX_MPLAYERX_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

typedef struct RemoteCommandParameter
{
	CString szRemoteCommandName;
	BOOL fAcceptRepeat;
	UINT nWndCommand;
} RemoteCommandParameter;

#define INI_SETTINGS_MISC _T("Miscellaneous")
#define INI_SETTINGS_GENERAL _T("General")
#define INI_SETTINGS_LIRC _T("Lirc")
#define INI_SETTINGS_OSD _T("OSD")

#define WM_OPEN_FILE (WM_USER + 21)

LPCTSTR AfxGetExecutableName();
BOOL AfxGetProfileFont(LPCTSTR lpszKey, LPCTSTR lpszVal, CFont& font, CDC* pDC);
BOOL AfxWriteProfileFont(LPCTSTR lpszKey, LPCTSTR lpszVal, CFont& font, CDC* pDC);
void AfxMessageBoxEx(LPCTSTR lpszText);
BOOL AfxDoEvents();

/////////////////////////////////////////////////////////////////////////////
// CMPlayerXApp:
// See MPlayerX.cpp for the implementation of this class
//

class CMPlayerXApp : public CWinApp
{
public:
	CMPlayerXApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMPlayerXApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	virtual void OnUpdateRecentFileMenu(CCmdUI* pCmdUI);
	//}}AFX_VIRTUAL

// Implementation

protected:
	BOOL m_fScreensaverStopped;

	void DoSaverSetting();
	void DoSaverPreview();
	void DoScreenSaver();

public:
	//{{AFX_MSG(CMPlayerXApp)
	afx_msg void OnAppAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MPLAYERX_H__INCLUDED_)
