//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEDIATIME_H__150D639A_6790_4C9A_A304_C2C04F479124__INCLUDED_)
#define AFX_MEDIATIME_H__150D639A_6790_4C9A_A304_C2C04F479124__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <dshow.h>
#include <comdef.h>

typedef enum EnumTimeFormat { TimeFormatNone = 0, TimeFormatFrame, TimeFormatByte,
	TimeFormatSample, TimeFormatField, TimeFormatMediaTime } EnumTimeFormat;

class CMediaTime  
{
public:
	CMediaTime();
	virtual ~CMediaTime();

	BOOL Init(IMediaSeeking* pMediaSeeking);
	void Close();
	LONGLONG GetTimeString(CString & szResult);
	BOOL GetCurrentPosition(REFERENCE_TIME & timeCurrent);

	EnumTimeFormat m_enTimeFormat;
	CString m_szDuration;
	LONGLONG m_llDuration;
	double m_timeAvgTimePerFrame;
	BOOL m_fUseFalseTime;
	UINT m_dwFrameStep;

	CComPtr<IMediaSeeking> m_pMediaSeeking;
};

#endif // !defined(AFX_MEDIATIME_H__150D639A_6790_4C9A_A304_C2C04F479124__INCLUDED_)
