//    NetExplorer - Windows LAN explorer application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// NetFind.cpp: implementation of the CNetFind class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NetFind.h"
#include "StringEx.h"
#include <Winsock2.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNetFind::CNetFind()
{
	m_pNetExplorer = NULL;
	m_lpfuncOnSearchNext = NULL;
	m_lpfuncOnSearchString = NULL;
//	m_lpfuncOnExpandHidden = NULL;
	m_lParam = 0;
	m_fSearchOnlyOne = TRUE;
	m_fSearching = FALSE;
	m_fSearchOnDirectory = FALSE;
	m_fDirectoryFound = FALSE;
}

void CNetFind::Init(CNetExplorerDoc * pNetExplorer, LPFuncOnSearchNext lpfuncOnSearchNext, /*LPFuncOnExpandHidden lpfuncOnExpandHidden, */LPARAM lParam, LPFuncOnSearchString lpfuncOnSearchString /*= NULL*/)
{
	m_pNetExplorer = pNetExplorer;
	m_lpfuncOnSearchNext = lpfuncOnSearchNext;
	m_lpfuncOnSearchString = lpfuncOnSearchString;
//	m_lpfuncOnExpandHidden = lpfuncOnExpandHidden;
	m_lParam = lParam;
	m_fSearchOnlyOne = TRUE;
	m_fSearching = FALSE;
}

CNetFind::~CNetFind()
{
	m_fMatchCase = TRUE;
}

//#include "Winnetwk.h"
#include <lm.h>
extern "C" {

	DWORD APIENTRY
	WNetGetResourceInformationA(
		LPNETRESOURCEA lpNetResource, // network resource
		LPVOID lpBuffer,             // information buffer
		LPDWORD lpcbBuffer,          // size of information buffer
		LPSTR *lplpSystem           // string
		);
	DWORD APIENTRY
	WNetGetResourceInformationW(
		LPNETRESOURCEW lpNetResource, // network resource
		LPVOID lpBuffer,             // information buffer
		LPDWORD lpcbBuffer,          // size of information buffer
		LPWSTR *lplpSystem           // string
		);
	#ifdef UNICODE
	#define WNetGetResourceInformation  WNetGetResourceInformationW
	#else
	#define WNetGetResourceInformation  WNetGetResourceInformationA
	#endif // !UNICODE


	DWORD APIENTRY
	WNetGetResourceParentA(
	  LPNETRESOURCEA lpNetResource,  // network resource 
	  LPVOID lpBuffer,              // buffer
	  LPDWORD lpcbBuffer            // buffer size
	);
	DWORD APIENTRY
	WNetGetResourceParentW(
	  LPNETRESOURCEW lpNetResource,  // network resource 
	  LPVOID lpBuffer,              // buffer
	  LPDWORD lpcbBuffer            // buffer size
	);
	#ifdef UNICODE
	#define WNetGetResourceParent  WNetGetResourceParentW
	#else
	#define WNetGetResourceParent  WNetGetResourceParentA
	#endif // !UNICODE
}

// Find only one Object
CTreeNodeList * CNetFind::Find(LPCTSTR pszThingsSearched)
{
	CWaitCursor wc;

	if(pszThingsSearched)
	{
		if(strncmp(pszThingsSearched, "\\\\", 2) == 0)
		{
			m_szThingsSearched = pszThingsSearched;

			CString szServerName;
			int nSlashPos = m_szThingsSearched.Find("\\", 2);
			if(nSlashPos != -1)
				szServerName = m_szThingsSearched.Left(nSlashPos);
			else
				szServerName = m_szThingsSearched;

			DWORD cbBufferOriginal = 16384;      // 16K is a good size
			DWORD cbBuffer = cbBufferOriginal;
			LPNETRESOURCE lpBuffer;     // pointer to enumerated structures
			LPTSTR lpSystem;
			// Call the GlobalAlloc function to allocate resources.
			lpBuffer = (LPNETRESOURCE)GlobalAlloc(GPTR, cbBuffer);
			ZeroMemory(lpBuffer, cbBuffer);
// Server
			BOOL fUseException = false;
			CString szServerName2 = szServerName.Mid(2);
			int nIp0, nIp1, nIp2, nIp3;
			if(_stscanf((LPCTSTR)szServerName2, _T("%d.%d.%d.%d"), &nIp0, &nIp1, &nIp2, &nIp3) == 4)
			{
				fUseException = true;
				//u_long res;
				//if((res = inet_addr(szServerName2)) != INADDR_NONE)
				//{
				//	struct hostent * hostinfo;
				//	if((hostinfo = gethostbyaddr((char*)&res, sizeof(res), AF_INET)) != NULL)
				//	{
				//		szServerName2 = hostinfo->h_name;
				//		int nPos = szServerName2.Find(_T('.'));
				//		if(nPos != -1)
				//			szServerName2 = szServerName2.Left(nPos);
				//	}
				//}
			}


			NETRESOURCE NetResource;
			NetResource.dwScope       = RESOURCE_GLOBALNET;
			NetResource.dwType        = RESOURCETYPE_ANY;
			NetResource.lpProvider = NULL;
			NetResource.lpRemoteName = (LPSTR)(LPCTSTR)szServerName;
			if(WNetGetResourceInformation(&NetResource, lpBuffer, &cbBuffer, &lpSystem) == NO_ERROR && !fUseException)
			{
				CTreeNode * pCurrentTreeNode = new CTreeNode;
				CTreeNode * pServerTreeNode = pCurrentTreeNode;
				pCurrentTreeNode->nType = CTreeNode::Server;
				pCurrentTreeNode->nFieldMask = TN_PATH | TN_NAME | TN_COMMENT;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = szServerName2;
				pCurrentTreeNode->szPath = CString("\\\\") + pCurrentTreeNode->szName + "\\";
				if(lpBuffer->lpComment)
					pCurrentTreeNode->szComment = lpBuffer->lpComment;
				else
					pCurrentTreeNode->szComment = "";
				pCurrentTreeNode->pParent = new CTreeNode;
				pCurrentTreeNode = pCurrentTreeNode->pParent;
#if 1
// Domain
				cbBuffer = cbBufferOriginal;
				if(WNetGetResourceParent(lpBuffer, lpBuffer, &cbBuffer) != NO_ERROR)
				{
					delete pServerTreeNode->pParent;
					delete pServerTreeNode;
					return NULL;
				}

				pCurrentTreeNode->nType = CTreeNode::Domain;
				pCurrentTreeNode->nFieldMask = TN_PATH | TN_NAME | TN_COMMENT;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = lpBuffer->lpRemoteName + 1;
				pCurrentTreeNode->szName = CString(lpBuffer->lpRemoteName[0]) + strlwr((LPSTR)(LPCTSTR)pCurrentTreeNode->szName);
				pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
				if(lpBuffer->lpComment)
					pCurrentTreeNode->szComment = lpBuffer->lpComment;
				else
					pCurrentTreeNode->szComment = "";
				pCurrentTreeNode->pParent = new CTreeNode;
				pCurrentTreeNode = pCurrentTreeNode->pParent;
// NetProtocol
				pCurrentTreeNode->nType = CTreeNode::NetProtocol;
				pCurrentTreeNode->nFieldMask = TN_PATH | TN_NAME | TN_COMMENT;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = lpBuffer->lpProvider;
				pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
				if(lpBuffer->lpComment)
					pCurrentTreeNode->szComment = lpBuffer->lpComment;
				else
					pCurrentTreeNode->szComment = "";
				pCurrentTreeNode->pParent = new CTreeNode;
				pCurrentTreeNode = pCurrentTreeNode->pParent;
// Network
				pCurrentTreeNode->nType = CTreeNode::Network;
				pCurrentTreeNode->nFieldMask = TN_PATH | TN_NAME | TN_COMMENT;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = "All Network";
				pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
				pCurrentTreeNode->szComment = pCurrentTreeNode->szName;
				pCurrentTreeNode->pParent = new CTreeNode;
				pCurrentTreeNode = pCurrentTreeNode->pParent;
#else
// Network
				pCurrentTreeNode->nType = CTreeNode::NetNeighborhood;
				pCurrentTreeNode->nFieldMask = TN_PATH | TN_NAME | TN_COMMENT;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = "Network Neighborhood";
				pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
				pCurrentTreeNode->szComment = pCurrentTreeNode->szName;
				pCurrentTreeNode->pParent = new CTreeNode;
				pCurrentTreeNode = pCurrentTreeNode->pParent;
#endif
// Desktop
				pCurrentTreeNode->nType = CTreeNode::Desktop;
				pCurrentTreeNode->nFieldMask = TN_LPARAM;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = "Desktop";
				pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
				pCurrentTreeNode->szComment = pCurrentTreeNode->szName;
				pCurrentTreeNode->pParent = NULL;

				m_fSearchOnlyOne = TRUE;
				m_fSearching = TRUE;
				m_fSearchOnDirectory = TRUE;

				Enumerate(pServerTreeNode, pServerTreeNode->pParent);

				// Call the GlobalFree function to free the memory.
				GlobalFree((HGLOBAL)lpBuffer);
			}
			else
			{
				CString szServerName2 = szServerName.Mid(2);
				CStringList * pStringListHiddens = m_pNetExplorer->m_mapHiddensByParentName["All Network"];
				if(pStringListHiddens == NULL)
				{
					pStringListHiddens = new CStringList();
					m_pNetExplorer->m_mapHiddensByParentName["All Network"] = pStringListHiddens;
				}

				if(pStringListHiddens->Find(szServerName2) == NULL)
					pStringListHiddens->AddTail(szServerName2);

				CString szShare = m_szThingsSearched.Mid(2 + szServerName2.GetLength() + 1);
				int pos = szShare.Find('\\');
				if(pos != -1)
				{
					szShare = szShare.Left(pos);
					if(szShare.GetLength() > 0)
					{
						CStringList * pStringListHiddens = m_pNetExplorer->m_mapHiddensByParentName[szServerName2];
						if(pStringListHiddens == NULL)
						{
							pStringListHiddens = new CStringList();
							m_pNetExplorer->m_mapHiddensByParentName[szServerName2] = pStringListHiddens;
						}

						if(pStringListHiddens->Find(szShare) == NULL)
							pStringListHiddens->AddTail(szShare);
					}
				}

				CTreeNode * pCurrentTreeNode = new CTreeNode;
				CTreeNode * pServerTreeNode = pCurrentTreeNode;
				pCurrentTreeNode->nType = CTreeNode::Server;
				pCurrentTreeNode->nFieldMask = TN_PATH | TN_NAME | TN_COMMENT;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = szServerName2;
				pCurrentTreeNode->szPath = CString("\\\\") + pCurrentTreeNode->szName + "\\";
				if(lpBuffer->lpComment)
					pCurrentTreeNode->szComment = lpBuffer->lpComment;
				else
					pCurrentTreeNode->szComment = "";
				pCurrentTreeNode->pParent = new CTreeNode;
				pCurrentTreeNode = pCurrentTreeNode->pParent;
	// Network
				pCurrentTreeNode->nType = CTreeNode::Network;
				pCurrentTreeNode->nFieldMask = TN_PATH | TN_NAME | TN_COMMENT;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = "All Network";
				pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
				pCurrentTreeNode->szComment = pCurrentTreeNode->szName;
				pCurrentTreeNode->pParent = new CTreeNode;
				pCurrentTreeNode = pCurrentTreeNode->pParent;
	// Desktop
				pCurrentTreeNode->nType = CTreeNode::Desktop;
				pCurrentTreeNode->nFieldMask = TN_LPARAM;
				pCurrentTreeNode->lParam = (LPARAM)this;
				pCurrentTreeNode->szName = "Desktop";
				pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
				pCurrentTreeNode->szComment = pCurrentTreeNode->szName;
				pCurrentTreeNode->pParent = NULL;

				m_fSearchOnlyOne = TRUE;
				m_fSearching = TRUE;
				m_fSearchOnDirectory = TRUE;

				Enumerate(pServerTreeNode, pServerTreeNode->pParent);

				//return NULL;
			}
		}
		else if(pszThingsSearched[0] && pszThingsSearched[1] && pszThingsSearched[1] == ':')
		{
			m_szThingsSearched = pszThingsSearched;

			CTreeNode * pCurrentTreeNode = new CTreeNode;
			CTreeNode * pServerTreeNode = pCurrentTreeNode;
// WorkArea
			pCurrentTreeNode->nType = CTreeNode::WorkArea;
			pCurrentTreeNode->nFieldMask = TN_PATH | TN_NAME | TN_COMMENT;
			pCurrentTreeNode->lParam = (LPARAM)this;
			pCurrentTreeNode->szName = "Work Area";
			pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
			pCurrentTreeNode->szComment = pCurrentTreeNode->szName;
			pCurrentTreeNode->pParent = new CTreeNode;
			pCurrentTreeNode = pCurrentTreeNode->pParent;

// Desktop
			pCurrentTreeNode->nType = CTreeNode::Desktop;
			pCurrentTreeNode->nFieldMask = TN_LPARAM;
			pCurrentTreeNode->lParam = (LPARAM)this;
			pCurrentTreeNode->szName = "Desktop";
			pCurrentTreeNode->szPath = pCurrentTreeNode->szName;
			pCurrentTreeNode->szComment = pCurrentTreeNode->szName;
			pCurrentTreeNode->pParent = NULL;

			m_fSearchOnlyOne = TRUE;
			m_fSearching = TRUE;
			m_fSearchOnDirectory = TRUE;

			Enumerate(pServerTreeNode, pServerTreeNode->pParent);

			delete pCurrentTreeNode;
		}

		m_fSearching = FALSE;
	}

	return NULL;
}

//// Search Object
//void CNetFind::SearchStart(LPCTSTR pszThingsSearched, CTreeNode * pTreeNode)
//{
//	m_fSearchOnlyOne = FALSE;
//	m_fSearching = TRUE;
//	SearchContinue(pszThingsSearched, pTreeNode);
//}
//
//void CNetFind::SearchContinue(LPCTSTR pszThingsSearched, CTreeNode * pTreeNode)
//{
//	if(pTreeNode->pParent)
//	{
//		pTreeNode->pParent->nFieldMask |= TN_LPARAM;
//		pTreeNode->pParent->lParam = (LPARAM)this;
//	}
//	else
//	{
//		pTreeNode->nFieldMask |= TN_LPARAM;
//		pTreeNode->lParam = (LPARAM)this;
//	}
//
//	if(m_fRegExp)
//		m_szThingsSearched = pszThingsSearched;
//	else
//	{
//		m_szThingsSearched = pszThingsSearched;
//		m_szThingsSearched.Replace(".", "\\.");
//		m_szThingsSearched.Replace("*", ".*");
//		m_szThingsSearched.Replace("?", ".?");
//		m_szThingsSearched.Replace(";", "|");
//		m_szThingsSearched = "^" + m_szThingsSearched + "$";
//	}
//
//	::regcomp(&m_PatternBuffer, m_szThingsSearched, REG_EXTENDED | (m_fMatchCase ? 0 : REG_ICASE));
//
//	Enumerate(pTreeNode, pTreeNode->pParent);
//
//	regfree(&m_PatternBuffer);
//}
//
//void CNetFind::SearchStop()
//{
////	if(m_lpfuncOnSearchString)
////		m_lpfuncOnSearchString("Search complete", m_lParam);
//
//	m_fSearching = FALSE;
//}

BOOL CNetFind::Enumerate(CTreeNode * pTreeNode, CTreeNode * pParentTreeNode)
{
	if(!pTreeNode) return FALSE;

	if(pParentTreeNode)
	{
		pTreeNode->lParam = pParentTreeNode->lParam;
		pTreeNode->pParent = pParentTreeNode;
	}
	else
		pTreeNode->pParent = NULL;

	CNetFind * pNetFind = (CNetFind *)pTreeNode->lParam;
	if(pNetFind)
	{
		BOOL fContinueInSubfolders = FALSE;
		if(pNetFind->m_fSearching)
		{
			switch(pTreeNode->nType)
			{
			case CTreeNode::Desktop:
				if(pNetFind->m_lpfuncOnSearchString)
					pNetFind->m_lpfuncOnSearchString(pTreeNode->szPath, pNetFind->m_lParam);
				fContinueInSubfolders = pNetFind->m_pNetExplorer->EnumerateDesktop(pTreeNode, CNetFind::Enumerate);
				break;
			case CTreeNode::WorkArea:
				if(pNetFind->m_lpfuncOnSearchString)
					pNetFind->m_lpfuncOnSearchString(pTreeNode->szPath, pNetFind->m_lParam);
				fContinueInSubfolders = pNetFind->m_pNetExplorer->EnumerateWorkArea(pTreeNode, CNetFind::Enumerate);
				break;
			case CTreeNode::NetNeighborhood:
				if(pNetFind->m_lpfuncOnSearchString)
					pNetFind->m_lpfuncOnSearchString(pTreeNode->szPath, pNetFind->m_lParam);
				fContinueInSubfolders = pNetFind->m_pNetExplorer->EnumerateNetNeighborhood(pTreeNode, CNetFind::Enumerate);
				break;
			case CTreeNode::Network:
			case CTreeNode::NetProtocol:
			case CTreeNode::NetDirectory:
			case CTreeNode::Domain:
				if(pNetFind->m_lpfuncOnSearchString)
					pNetFind->m_lpfuncOnSearchString(pTreeNode->szPath, pNetFind->m_lParam);
				fContinueInSubfolders = pNetFind->m_pNetExplorer->EnumerateNetwork(pTreeNode, CNetFind::Enumerate);
				break;
			case CTreeNode::Server:
				if(pNetFind->m_lpfuncOnSearchString)
					pNetFind->m_lpfuncOnSearchString(pTreeNode->szPath, pNetFind->m_lParam);

				if(pNetFind->m_fSearchOnDirectory)
				{
					if(_strnicmp(pTreeNode->szPath, pNetFind->m_szThingsSearched + '\\', pTreeNode->szPath.GetLength()) == 0)
					{
						int nPos = pTreeNode->szPath.GetLength();
						CString szNextPath;
						int nSlashPos = pNetFind->m_szThingsSearched.Find("\\", nPos);
						if(nSlashPos != -1)
							szNextPath = pNetFind->m_szThingsSearched.Mid(nPos, nSlashPos - nPos);
						else if(nPos < pNetFind->m_szThingsSearched.GetLength())
							szNextPath = pNetFind->m_szThingsSearched.Mid(nPos);

						if(szNextPath.Right(1) == '$')
						{
							PSHARE_INFO_502 BufPtr;
							NET_API_STATUS res;
							WCHAR wszServer[256], wszPath[256];
							MultiByteToWideChar(CP_ACP, 0, pTreeNode->szName, strlen(pTreeNode->szName) + 1, wszServer, sizeof(wszServer) / sizeof(wszServer[0]));
							MultiByteToWideChar(CP_ACP, 0, szNextPath, strlen(szNextPath) + 1, wszPath, sizeof(wszPath) / sizeof(wszPath[0]));
							if((res = NetShareGetInfo(wszServer, wszPath, 502, (LPBYTE *)&BufPtr)) == ERROR_SUCCESS)
							{
								//printf("%S\t%S\t%u\n",BufPtr->shi502_netname, BufPtr->shi502_path, BufPtr->shi502_current_uses);
								//if (IsValidSecurityDescriptor(BufPtr->shi502_security_descriptor))
								//	printf("It has a valid Security Descriptor.\n");
								//else
								//	printf("It does not have a valid Security Descriptor.\n");
								NetApiBufferFree(BufPtr);

								CStringList * pStringListHiddens = pNetFind->m_pNetExplorer->m_mapHiddensByParentName[pTreeNode->szName];
								if(pStringListHiddens == NULL)
								{
									pStringListHiddens = new CStringList();
									pNetFind->m_pNetExplorer->m_mapHiddensByParentName[pTreeNode->szName] = pStringListHiddens;
								}

								if(pStringListHiddens->Find(szNextPath) == NULL)
									pStringListHiddens->AddTail(szNextPath);
							}
							else 
							{
								//printf("Error: %ld\n", res);
								pNetFind->m_fSearching = FALSE;
							}
						}

						CTreeNodeList * pTreeNodePathList = new CTreeNodeList;
						pTreeNodePathList->AddTail(new CTreeNode(*pTreeNode));
						CTreeNode * pParentTreeNode = pTreeNode;
						while(pParentTreeNode = pParentTreeNode->pParent)
							pTreeNodePathList->AddTail(new CTreeNode(*pParentTreeNode));
						if(pNetFind->m_lpfuncOnSearchNext)
							pNetFind->m_lpfuncOnSearchNext(pTreeNodePathList, pNetFind->m_lParam);
					}
					else
						break;
				}

				fContinueInSubfolders = pNetFind->m_pNetExplorer->EnumerateShare(pTreeNode, CNetFind::Enumerate);
				break;
			case CTreeNode::Share:
			case CTreeNode::NetShare:
			case CTreeNode::Drive:
			case CTreeNode::Directory:
				if(pNetFind->m_lpfuncOnSearchString)
					pNetFind->m_lpfuncOnSearchString(pTreeNode->szPath, pNetFind->m_lParam);

				if(pNetFind->m_fSearchOnDirectory)
				{
					if(_strnicmp(pTreeNode->szPath, pNetFind->m_szThingsSearched + '\\', pTreeNode->szPath.GetLength()) == 0)
					{
						CTreeNodeList * pTreeNodePathList = new CTreeNodeList;
						pTreeNodePathList->AddTail(new CTreeNode(*pTreeNode));
						CTreeNode * pParentTreeNode = pTreeNode;
						while(pParentTreeNode = pParentTreeNode->pParent)
							pTreeNodePathList->AddTail(new CTreeNode(*pParentTreeNode));
						if(pNetFind->m_lpfuncOnSearchNext)
							pNetFind->m_lpfuncOnSearchNext(pTreeNodePathList, pNetFind->m_lParam);

						int nPos = pTreeNode->szPath.GetLength();
						CString szNextPath;
						int nSlashPos = pNetFind->m_szThingsSearched.Find("\\", nPos);
						if(nSlashPos != -1)
							szNextPath = pNetFind->m_szThingsSearched.Mid(nPos, nSlashPos - nPos);
						else if(nPos < pNetFind->m_szThingsSearched.GetLength())
							szNextPath = pNetFind->m_szThingsSearched.Mid(nPos);

						szNextPath = pTreeNode->szPath + szNextPath;
						WIN32_FIND_DATA FindFileData;
						HANDLE hFind;
						hFind = FindFirstFile(szNextPath, &FindFileData);
						if(hFind != INVALID_HANDLE_VALUE)
							FindClose(hFind);
						else 
							pNetFind->m_fSearching = FALSE;
					}
					else
						break;
				}

				fContinueInSubfolders = pNetFind->m_pNetExplorer->EnumerateFiles(ENUM_DIRECTORIES | (pNetFind->m_fSearchOnDirectory ? 0 : ENUM_FILES), (CNetExplorerDoc::SortType)0, pTreeNode, CNetFind::Enumerate);
				break;
			case CTreeNode::File:
				//if(regexec(&pNetFind->m_PatternBuffer, pTreeNode->szName, 0, 0, 0) == 0)
				//{
				//	CTreeNodeList * pTreeNodePathList = new CTreeNodeList;
				//	pTreeNodePathList->AddTail(new CTreeNode(*pTreeNode));
				//	CTreeNode * pParentTreeNode = pTreeNode;
				//	while(pParentTreeNode = pParentTreeNode->pParent)
				//		pTreeNodePathList->AddTail(new CTreeNode(*pParentTreeNode));
				//	if(pNetFind->m_lpfuncOnSearchNext)
				//		pNetFind->m_lpfuncOnSearchNext(pTreeNodePathList, pNetFind->m_lParam);
				//	if(pNetFind->m_fSearchOnlyOne)
				//		pNetFind->m_fSearching = FALSE;
				//	break;
				//}
				break;
			default:
				return FALSE;
			}
		}
		delete pTreeNode;
		return TRUE;
	}
	return FALSE;
}
