//    NetExplorer - Windows LAN explorer application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// NetFind.h: interface for the CNetFind class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NETFIND_H__INCLUDED_)
#define AFX_NETFIND_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NetExplorerDoc.h"

typedef void (* LPFuncOnSearchNext)(CTreeNodeList *, LPARAM);
typedef void (* LPFuncOnSearchString)(LPCTSTR, LPARAM);

//#define __STDC__ 1
//extern "C" {
//	#include "regex/regex.h"
//}
//#undef __STDC__

class CFindParameters;

class CNetFind  
{
public:
	CNetFind();
	virtual ~CNetFind();

	void Init(CNetExplorerDoc * pNetExplorer, LPFuncOnSearchNext lpfuncOnSearchNext, LPARAM lParam, LPFuncOnSearchString lpfuncOnSearchString = NULL);

	// Find only one Object
	CTreeNodeList * Find(LPCTSTR pszThingsSearched);

	// Search Object
	void SearchStart(LPCTSTR pszThingsSearched, CTreeNode * pTreeNode);
	void SearchContinue(LPCTSTR pszThingsSearched, CTreeNode * pTreeNode);
	void SearchStop();
	
	LPFuncOnSearchNext m_lpfuncOnSearchNext;
	LPFuncOnSearchString m_lpfuncOnSearchString;

	LPARAM m_lParam;

	CFindParameters * m_pFindParameters;

	BOOL m_fSearchOnlyOne;
	BOOL m_fSearching;

	BOOL m_fSearchOnDirectory;
	BOOL m_fDirectoryFound;

	BOOL m_fMatchCase;
	BOOL m_fRegExp;

	CString m_szThingsSearched;
	//regex_t m_PatternBuffer;

	static BOOL Enumerate(CTreeNode * pTreeNode, CTreeNode * pParentTreeNode);
protected:

	CNetExplorerDoc * m_pNetExplorer;
};

#endif // !defined(AFX_NETFIND_H__INCLUDED_)
