//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#if !defined(AFX_PLAYLISTDIALOGBAR_H__INCLUDED_)
#define AFX_PLAYLISTDIALOGBAR_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PlayListDialogBar.h : header file
//

#include "PlayListListCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CPlayListDialogBar window

class CPlayListDialogBar : public CSizingControlBarG
{
	friend class CPlayListListCtrl;
// Construction
public:
	CPlayListDialogBar();

// Attributes
public:

// Operations
public:
	BOOL AddFileToTail(LPCTSTR pszFilename, BOOL fSetCurrent = FALSE);
	void SetCurrentFile(LPCTSTR pszFilename);
	LPCTSTR GetCurrentFile();
	LPCTSTR GetPreviousFile();
	LPCTSTR GetNextFile();
	int GetCurrentFileId();
	int GetCount() { return m_wndPlayListListCtrl.GetItemCount(); }
	LPCTSTR GetFile(int nItem);
	BOOL IsCurrentSelected();
	void DeleteCurrentFile();
	void DeleteSelectedFile();
	void DeleteAllFile();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlayListDialogBar)
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CPlayListDialogBar();

protected:
	CPlayListListCtrl m_wndPlayListListCtrl;
//	CListCtrl m_wndPlayListListCtrl;

protected:
	void UpdateColumnWidth();

	DWORD m_dwCurrentFile;
	CImageList m_ImageList;

	CImageList* m_pDragImage;	//For creating and managing the drag-image
	BOOL		m_bDragging;	//T during a drag operation
	int			m_nDragIndex;	//Index of selected item in the List we are dragging FROM
	int			m_nDropIndex;	//Index at which to drop item in the List we are dropping ON

	// Generated message map functions
protected:
	//{{AFX_MSG(CPlayListDialogBar)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDblclkList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRclickList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEndScrollList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnBegindragList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLAYLISTDIALOGBAR_H__INCLUDED_)
