//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//
// PlayListListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "mplayerx.h"
#include "PlayListListCtrl.h"
#include "PlayListDialogBar.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayListListCtrl

CPlayListListCtrl::CPlayListListCtrl()
{
}

CPlayListListCtrl::~CPlayListListCtrl()
{
}


BEGIN_MESSAGE_MAP(CPlayListListCtrl, CListCtrl)
	//{{AFX_MSG_MAP(CPlayListListCtrl)
	ON_WM_DROPFILES()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayListListCtrl message handlers

void CPlayListListCtrl::OnDropFiles(HDROP hDropInfo) 
{
	//
	// Get the number of pathnames (files or folders) dropped
	//
	UINT nNumFilesDropped = DragQueryFile(hDropInfo, 0xFFFFFFFF, NULL, 0);
	
	POINT point;
	int nItem = -1;
	if(DragQueryPoint(hDropInfo, &point))
		nItem = HitTest(point);
	
	if(nItem == -1)
		nItem = GetItemCount();
	
	CArray<CString, LPCTSTR> aszDropedFile;

	//
	// Iterate through the pathnames and process each one
	//
	TCHAR szPathname[MAX_PATH + 1];
	for (UINT nFile = 0 ; nFile < nNumFilesDropped; nFile++)
	{
		DragQueryFile(hDropInfo, nFile, szPathname, MAX_PATH + 1);
		aszDropedFile.Add(szPathname);
	}

	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();

	for (nFile = 0 ; nFile < nNumFilesDropped; nFile++)
	{
		CString szFilename = aszDropedFile[nFile];
		int nPos = szFilename.ReverseFind(_T('\\'));
		if(nPos != -1)
			szFilename = szFilename.Mid(nPos + 1);
		
		int iItem = InsertItem(nItem + nFile, szFilename);
		SetItemText(iItem, 1, _T(""));
		TCHAR * pszFilename = _tcsdup(aszDropedFile[nFile]);
		SetItemData(iItem, (DWORD)pszFilename);

		if(pMainFrame)
			pMainFrame->AddFileToRecentFileList(pszFilename);
	}

	SetColumnWidth(0, -1);
	
	//
	// Free the dropped-file info that was allocated by windows
	//
	DragFinish(hDropInfo);
	
	CPlayListDialogBar * pPlayListDialogBar = (CPlayListDialogBar *)GetParent();
	if(pPlayListDialogBar && GetItemCount())
	{
		if(pMainFrame && pMainFrame->m_enCurrentPlayState == PSUnload)
			pMainFrame->PlayFile((LPCTSTR)GetItemData(0), TRUE);
	}

	CListCtrl::OnDropFiles(hDropInfo);
}
