//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//
// SeekingDialogBar.cpp : implementation file
//

#include "stdafx.h"
#include "MPlayerX.h"
#include "SeekingDialogBar.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSeekingDialogBar

CSeekingDialogBar::CSeekingDialogBar()
{
}

CSeekingDialogBar::~CSeekingDialogBar()
{
}

// preffered creation method
BOOL CSeekingDialogBar::Create(LPCTSTR lpszWindowName,
                               CWnd* pParentWnd, UINT nID,
                               DWORD dwStyle)
{
    // must have a parent
    ASSERT_VALID(pParentWnd);
    // cannot be both fixed and dynamic
    // (CBRS_SIZE_DYNAMIC is used for resizng when floating)
    ASSERT (!((dwStyle & CBRS_SIZE_FIXED) &&
              (dwStyle & CBRS_SIZE_DYNAMIC)));

    m_dwStyle = dwStyle & CBRS_ALL; // save the control bar styles

    // register and create the window - skip CControlBar::Create()
    CString wndclass = ::AfxRegisterWndClass(CS_DBLCLKS, //NULL,
        ::LoadCursor(NULL, IDC_ARROW),
        ::GetSysColorBrush(COLOR_BTNFACE), 0);

    dwStyle &= ~CBRS_ALL; // keep only the generic window styles
    dwStyle |= WS_CLIPCHILDREN; // prevents flashing
    if (!CWnd::Create(wndclass, lpszWindowName, dwStyle,
        CRect(0, 0, 0, 0), pParentWnd, nID))
        return FALSE;

    return TRUE;
}

BEGIN_MESSAGE_MAP(CSeekingDialogBar, CControlBar)
	//{{AFX_MSG_MAP(CSeekingDialogBar)
	ON_WM_CREATE()
	ON_WM_HSCROLL()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSeekingDialogBar message handlers

int CSeekingDialogBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if(CControlBar::OnCreate(lpCreateStruct) == -1)
		return -1;

	if(!m_wndSliderBar.Create(WS_CHILD | WS_VISIBLE |
			TBS_HORZ | TBS_TOP | TBS_ENABLESELRANGE |
			TBS_NOTICKS, // TBS_NOTICKS TBS_AUTOTICKS,
		CRect(10, 0, 0, 0), this, IDC_SLIDER_MOVIE))
		return -1;

//	m_wndSliderBar.SetTicFreq(1000000);

	return 0;
}

void CSeekingDialogBar::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CSliderCtrl * pSliderCtrl = (CSliderCtrl *)pScrollBar;
	if(pScrollBar && pScrollBar->m_hWnd == m_wndSliderBar.m_hWnd)
	{
		CMainFrame * pParent = (CMainFrame *)AfxGetMainWnd();
		if(pParent)
			pParent->OnHScroll(nSBCode, nPos, pScrollBar);
	}
	
	CControlBar::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CSeekingDialogBar::OnSize(UINT nType, int cx, int cy) 
{
	CControlBar::OnSize(nType, cx, cy);
	
/*	if(cx >= cy)
		m_wndSliderBar.ModifyStyle(0, TBS_HORZ);
	else
		m_wndSliderBar.ModifyStyle(0, TBS_VERT);
*/
	m_wndSliderBar.MoveWindow(10, 1, cx - 10, cy - 1);
}

CSize CSeekingDialogBar::CalcDynamicLayout(int, DWORD nMode)
{
	return CalcFixedLayout(nMode & LM_STRETCH, nMode & LM_HORZ);
}

CSize CSeekingDialogBar::CalcFixedLayout(BOOL bStretch, BOOL bHorz)
{
	CWnd * pWnd = AfxGetMainWnd();
	if(pWnd)
	{
		CRect rectFrame, rectBar;
		pWnd->GetWindowRect(&rectFrame);

		CPoint pointBar(0, 0);
		ClientToScreen(&pointBar);
		pWnd->ScreenToClient(&pointBar);
		
		return CSize(rectFrame.Width() - (IsFloating() ? 0 : pointBar.x) - 15, 35);
	}

	return CSize(200, 35);
}
