//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// SeekingSliderCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "mplayerx.h"
#include "SeekingSliderCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSeekingSliderCtrl

CSeekingSliderCtrl::CSeekingSliderCtrl()
{
	m_fDragging = FALSE;
}

CSeekingSliderCtrl::~CSeekingSliderCtrl()
{
}


BEGIN_MESSAGE_MAP(CSeekingSliderCtrl, CSliderCtrl)
	//{{AFX_MSG_MAP(CSeekingSliderCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSeekingSliderCtrl message handlers

void CSeekingSliderCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if(!m_fDragging)
	{
		m_fDragging = TRUE;
		SetCapture();
		SetFocus();

		SetKnob(point);
		PostMessageToParent(TB_THUMBPOSITION);
	}
	else
	{
		CSliderCtrl::OnLButtonDown(nFlags, point);
	}
}

void CSeekingSliderCtrl::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if(m_fDragging)
	{
		m_fDragging = FALSE;
		::ReleaseCapture();
		SetKnob(point);
		PostMessageToParent(TB_THUMBPOSITION);
//		RedrawWindow();
	}
	else
	{
		CSliderCtrl::OnLButtonUp(nFlags, point);
	}
}

void CSeekingSliderCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_fDragging)
	{
		SetKnob(point);
		PostMessageToParent(TB_THUMBTRACK);
//		PostMessageToParent(TB_THUMBPOSITION);
//		RedrawWindow();
	}
	else
	{
		CSliderCtrl::OnMouseMove(nFlags, point);
	}
}

void CSeekingSliderCtrl::SetKnob(CPoint &point)
{
	CRect rectChannel, rectThumb;
	GetChannelRect(&rectChannel);
	GetThumbRect(&rectThumb);

	int nRangeMin = GetRangeMin();
	int nRangeMax = GetRangeMax();
	int nThumbCorrection = rectThumb.Width() / 2;
	int nPosMin = rectChannel.left + nThumbCorrection;
	int nPosMax = rectChannel.right - nThumbCorrection;
	LONGLONG llNewPos = (LONGLONG)(nRangeMax - nRangeMin) * (LONGLONG)(point.x - nPosMin);
	if(llNewPos < 0)
		SetPos(0);
	else if(nPosMax != nPosMin)
	{
		llNewPos /= nPosMax - nPosMin;
		int nNewPos = (int)llNewPos + nRangeMin;
		if(nNewPos > nRangeMax)
			nNewPos = nRangeMax;
		SetPos(nNewPos);
	}
}

void CSeekingSliderCtrl::PostMessageToParent(UINT nSBCode)
{
	CWnd* pWnd = GetParent();
	if(pWnd)
		pWnd->PostMessage(WM_HSCROLL, (WPARAM)((GetPos() << 16) | nSBCode), (LPARAM)GetSafeHwnd());
}
