//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// SettingsData.h: interface for the CSettingsData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGSDATA_H__INCLUDED_)
#define AFX_SETTINGSDATA_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSettingsData  
{
public:
	CSettingsData();
	virtual ~CSettingsData();

	// Miscellanous
	BOOL	m_fTopMost;
	CRect	m_rectWindowPosition;
	BOOL	m_fPlayRandom;
	BOOL	m_fSoundMute;
	long	m_nSoundLevel;
	long	m_nSoundBalance;
	BOOL	m_fUseOverlayWhenPossible;
	BOOL	m_fShowOSD;
	int		m_nSortAttribute;

	// General
	BOOL	m_fGeneralDirty;

	BOOL	m_fOnlyOneInstance;
	BOOL	m_fSlideshow;
	UINT	m_nSlideshowWaitingTime;
	BOOL	m_fUseDelayFilter;

	// Screensaver
	BOOL	m_fScreensaverDirty;

	BOOL	m_fScreensaverInstall;
	BOOL	m_fScreensaverMute;
	BOOL	m_fScreensaverRandom;
	CString	m_szScreensaverPlaylistFile;

	// Lirc
	BOOL m_fLircDirty;

	CString m_szGirderPluginFilename;
	CArray<RemoteCommandParameter, RemoteCommandParameter&> m_aLircCommandParameters;

	// OSD
	BOOL m_fOSDDirty;

	CFont m_fontOSD;
	COLORREF m_colorOSDFont;
	COLORREF m_colorOSDBackgroundFont;
	BOOL m_fOSDTransparent;
	long m_nOSDPosX;
	long m_nOSDPosY;

	// Subtitle
	BOOL m_fSubtitleDirty;

	CFont m_fontSubtitle;
	COLORREF m_colorSubtitleFont;
	COLORREF m_colorSubtitleBackgroundFont;
	BOOL m_fSubtitleTransparent;
	long m_nSubtitlePosY;

	// TimeLine
	BOOL m_fTimeLineDirty;

	CFont m_fontTimeLine;
	COLORREF m_colorTimeLineFont;
	COLORREF m_colorTimeLineBackgroundFont;
	BOOL m_fTimeLineTransparent;
	long m_nTimeLinePosY;
};

#endif // !defined(AFX_SETTINGSDATA_H__INCLUDED_)
