//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// SettingsGeneralPropertyPage.cpp : implementation file
//

#include "stdafx.h"
#include "mplayerx.h"
#include "SettingsGeneralPropertyPage.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsGeneralPropertyPage property page

IMPLEMENT_DYNCREATE(CSettingsGeneralPropertyPage, CPropertyPage)

CSettingsGeneralPropertyPage::CSettingsGeneralPropertyPage() : CPropertyPage(CSettingsGeneralPropertyPage::IDD)
, m_fUseDelayFilter(FALSE)
{
	//{{AFX_DATA_INIT(CSettingsGeneralPropertyPage)
	m_fSlideshow = FALSE;
	m_nSlideshowWaitingTime = 0;
	m_fOnlyOneInstance = FALSE;
	//}}AFX_DATA_INIT
}

CSettingsGeneralPropertyPage::~CSettingsGeneralPropertyPage()
{
}

void CSettingsGeneralPropertyPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsGeneralPropertyPage)
	DDX_Check(pDX, IDC_CHECK_SLIDESHOW, m_fSlideshow);
	DDX_Text(pDX, IDC_EDIT_SLIDESHOW_WAITING_TIME, m_nSlideshowWaitingTime);
	DDV_MinMaxUInt(pDX, m_nSlideshowWaitingTime, 0, 120000);
	DDX_Check(pDX, IDC_CHECK_ONLY_ONE_INSTANCE, m_fOnlyOneInstance);
	//}}AFX_DATA_MAP
	DDX_Check(pDX, IDC_CHECK_USE_DELAY_FILTER, m_fUseDelayFilter);
}


BEGIN_MESSAGE_MAP(CSettingsGeneralPropertyPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSettingsGeneralPropertyPage)
	ON_BN_CLICKED(IDC_CHECK_SLIDESHOW, OnCheckSlideshow)
	ON_EN_CHANGE(IDC_EDIT_SLIDESHOW_WAITING_TIME, OnChangeEditSlideshowWaitingTime)
	ON_BN_CLICKED(IDC_CHECK_ONLY_ONE_INSTANCE, OnCheckOnlyOneInstance)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CHECK_USE_DELAY_FILTER, OnBnClickedCheckUseDelayFilter)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsGeneralPropertyPage message handlers

BOOL CSettingsGeneralPropertyPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		m_fOnlyOneInstance = pMainFrame->m_SettingsTemp.m_fOnlyOneInstance = pMainFrame->m_SettingsCurrent.m_fOnlyOneInstance;

		m_fSlideshow = pMainFrame->m_SettingsTemp.m_fSlideshow = pMainFrame->m_SettingsCurrent.m_fSlideshow;
		m_nSlideshowWaitingTime = pMainFrame->m_SettingsTemp.m_nSlideshowWaitingTime = pMainFrame->m_SettingsCurrent.m_nSlideshowWaitingTime;

		m_fUseDelayFilter = pMainFrame->m_SettingsTemp.m_fUseDelayFilter = pMainFrame->m_SettingsCurrent.m_fUseDelayFilter;

		UpdateData(FALSE);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsGeneralPropertyPage::OnCheckSlideshow() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		UpdateData();
		pMainFrame->m_SettingsTemp.m_fGeneralDirty = TRUE;
		pMainFrame->m_SettingsTemp.m_fSlideshow = m_fSlideshow;
	}
}

void CSettingsGeneralPropertyPage::OnChangeEditSlideshowWaitingTime() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		UpdateData();
		pMainFrame->m_SettingsTemp.m_fGeneralDirty = TRUE;
		pMainFrame->m_SettingsTemp.m_nSlideshowWaitingTime = m_nSlideshowWaitingTime;
	}
}

void CSettingsGeneralPropertyPage::OnCheckOnlyOneInstance() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		UpdateData();
		pMainFrame->m_SettingsTemp.m_fGeneralDirty = TRUE;
		pMainFrame->m_SettingsTemp.m_fOnlyOneInstance = m_fOnlyOneInstance;
	}
}


void CSettingsGeneralPropertyPage::OnBnClickedCheckUseDelayFilter()
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		UpdateData();
		pMainFrame->m_SettingsTemp.m_fGeneralDirty = TRUE;
		pMainFrame->m_SettingsTemp.m_fUseDelayFilter = m_fUseDelayFilter;
	}
}
