//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#if !defined(AFX_SETTINGSLIRCPROPERTYPAGE_H__INCLUDED_)
#define AFX_SETTINGSLIRCPROPERTYPAGE_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SettingsLircPropertyPage.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSettingsLircPropertyPage dialog

class CSettingsLircPropertyPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CSettingsLircPropertyPage)
	friend class CMainFrame;
// Construction
public:
	CSettingsLircPropertyPage();
	~CSettingsLircPropertyPage();

// Dialog Data
	//{{AFX_DATA(CSettingsLircPropertyPage)
	enum { IDD = IDD_DIALOG_SETTINGS_LIRC };
	CButton	m_wndButtonConfig;
	CButton	m_wndButtonLearn;
	CButton	m_wndButtonPluginBrowse;
	CListBox	m_wndListBoxCommand;
	CString	m_szRemoteCommand;
	BOOL	m_fAcceptRepeat;
	CString	m_szGirderPluginFilePath;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSettingsLircPropertyPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL m_fLearnAllowed;
	BOOL m_fLircInitialize;
	BOOL m_fLircSupport;
	BOOL ConnectRemoteControl();

	// Generated message map functions
	//{{AFX_MSG(CSettingsLircPropertyPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeListCommand();
	afx_msg void OnCheckAcceptRepeat();
	afx_msg void OnChangeEditRemoteCommand();
	afx_msg void OnButtonResetMapping();
	afx_msg void OnButtonGirderPluginBrowse();
	afx_msg void OnChangeEditGirderPluginFile();
	afx_msg void OnButtonLearn();
	afx_msg void OnButtonGirderPluginConfig();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETTINGSLIRCPROPERTYPAGE_H__INCLUDED_)
