//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// SettingsOSDPropertyPage.cpp : implementation file
//

#include "stdafx.h"
#include "mplayerx.h"
#include "SettingsOSDPropertyPage.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsOSDPropertyPage property page

IMPLEMENT_DYNCREATE(CSettingsOSDPropertyPage, CPropertyPage)

CSettingsOSDPropertyPage::CSettingsOSDPropertyPage() : CPropertyPage(CSettingsOSDPropertyPage::IDD)
{
	//{{AFX_DATA_INIT(CSettingsOSDPropertyPage)
	m_fTransparent = FALSE;
	m_nPosX = 0;
	m_nPosY = 0;
	//}}AFX_DATA_INIT

	m_fDialogInitialized = FALSE;
}

CSettingsOSDPropertyPage::~CSettingsOSDPropertyPage()
{
}

void CSettingsOSDPropertyPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsOSDPropertyPage)
	DDX_Control(pDX, IDC_SPIN_POS_Y, m_wndSpinPosY);
	DDX_Control(pDX, IDC_SPIN_POS_X, m_wndSpinPosX);
	DDX_Control(pDX, IDC_STATIC_SAMPLE, m_wndStatic);
	DDX_Check(pDX, IDC_CHECK_TRANSPARENT, m_fTransparent);
	DDX_Text(pDX, IDC_EDIT_POS_X, m_nPosX);
	DDX_Text(pDX, IDC_EDIT_POS_Y, m_nPosY);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsOSDPropertyPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSettingsOSDPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_FONT, OnButtonSelectFont)
	ON_BN_CLICKED(IDC_BUTTON_BACKGROUND_COLOR, OnButtonBackgroundColor)
	ON_BN_CLICKED(IDC_CHECK_TRANSPARENT, OnCheckTransparent)
	ON_EN_CHANGE(IDC_EDIT_POS_X, OnChangeEditPosX)
	ON_EN_CHANGE(IDC_EDIT_POS_Y, OnChangeEditPosY)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsOSDPropertyPage message handlers

BOOL CSettingsOSDPropertyPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		LOGFONT lf;
		pMainFrame->m_SettingsCurrent.m_fontOSD.GetLogFont(&lf);
		if(pMainFrame->m_SettingsTemp.m_fontOSD.m_hObject)
			pMainFrame->m_SettingsTemp.m_fontOSD.DeleteObject();
		lf.lfQuality |= ANTIALIASED_QUALITY; // | CLEARTYPE_QUALITY;
		pMainFrame->m_SettingsTemp.m_fontOSD.CreateFontIndirect(&lf);
		pMainFrame->m_SettingsTemp.m_colorOSDFont = pMainFrame->m_SettingsCurrent.m_colorOSDFont;
		pMainFrame->m_SettingsTemp.m_colorOSDBackgroundFont = pMainFrame->m_SettingsCurrent.m_colorOSDBackgroundFont;

		m_fTransparent = pMainFrame->m_SettingsTemp.m_fOSDTransparent = pMainFrame->m_SettingsCurrent.m_fOSDTransparent;

		m_nPosX = pMainFrame->m_SettingsTemp.m_nOSDPosX = pMainFrame->m_SettingsCurrent.m_nOSDPosX;
		m_nPosY = pMainFrame->m_SettingsTemp.m_nOSDPosY = pMainFrame->m_SettingsCurrent.m_nOSDPosY;


		m_wndStatic.SetFont(&pMainFrame->m_SettingsTemp.m_fontOSD);
		m_wndStatic.m_colorFont = pMainFrame->m_SettingsTemp.m_colorOSDFont;
		m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorOSDBackgroundFont;
		m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fOSDTransparent;
	}

	m_wndSpinPosX.SetPos(m_nPosX);
	m_wndSpinPosY.SetPos(m_nPosY);
	m_wndSpinPosX.SetRange32(-99999, 99999);
	m_wndSpinPosY.SetRange32(-99999, 99999);

	m_fDialogInitialized = TRUE;
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsOSDPropertyPage::OnButtonSelectFont() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		LOGFONT logfont;
		pMainFrame->m_SettingsTemp.m_fontOSD.GetLogFont(&logfont);
		CFontDialog dlg(&logfont, CF_EFFECTS | CF_SCREENFONTS, NULL, this);
		dlg.m_cf.rgbColors = pMainFrame->m_SettingsTemp.m_colorOSDFont;
		if(dlg.DoModal() == IDOK)
		{
			pMainFrame->m_SettingsTemp.m_fontOSD.DeleteObject();
			logfont.lfQuality |= ANTIALIASED_QUALITY; // | CLEARTYPE_QUALITY;
			pMainFrame->m_SettingsTemp.m_fontOSD.CreateFontIndirect(&logfont);
			pMainFrame->m_SettingsTemp.m_colorOSDFont = dlg.GetColor();

			m_wndStatic.SetFont(&pMainFrame->m_SettingsTemp.m_fontOSD);
			m_wndStatic.m_colorFont = pMainFrame->m_SettingsTemp.m_colorOSDFont;
			m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorOSDFont;
			m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fOSDTransparent;

			pMainFrame->m_SettingsTemp.m_fOSDDirty = TRUE;

			Invalidate();
		}
	}
}

void CSettingsOSDPropertyPage::OnButtonBackgroundColor() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		CColorDialog dlg(pMainFrame->m_SettingsTemp.m_colorOSDBackgroundFont, CC_FULLOPEN); //CC_RGBINIT);
		if(dlg.DoModal() == IDOK)
		{
			m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorOSDBackgroundFont = dlg.GetColor();
			pMainFrame->m_SettingsTemp.m_fOSDDirty = TRUE;

			Invalidate();
		}
	}
}

void CSettingsOSDPropertyPage::OnCheckTransparent() 
{
	UpdateData();
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fOSDTransparent = m_fTransparent;
		pMainFrame->m_SettingsTemp.m_fOSDDirty = TRUE;

		Invalidate();
	}
}

void CSettingsOSDPropertyPage::OnChangeEditPosX() 
{
	if(!m_fDialogInitialized)
		return;
	UpdateData();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		pMainFrame->m_SettingsTemp.m_nOSDPosX = m_nPosX;
		pMainFrame->m_SettingsTemp.m_fOSDDirty = TRUE;
	}
}

void CSettingsOSDPropertyPage::OnChangeEditPosY() 
{
	if(!m_fDialogInitialized)
		return;
	UpdateData();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		pMainFrame->m_SettingsTemp.m_nOSDPosY = m_nPosY;
		pMainFrame->m_SettingsTemp.m_fOSDDirty = TRUE;
	}
}
