//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// SettingsScreensaverPropertyPage.cpp : implementation file
//

#include "stdafx.h"
#include "mplayerx.h"
#include "SettingsScreensaverPropertyPage.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsScreensaverPropertyPage property page

IMPLEMENT_DYNCREATE(CSettingsScreensaverPropertyPage, CPropertyPage)

CSettingsScreensaverPropertyPage::CSettingsScreensaverPropertyPage() : CPropertyPage(CSettingsScreensaverPropertyPage::IDD)
{
	//{{AFX_DATA_INIT(CSettingsScreensaverPropertyPage)
	m_szScreensaverPlaylistFile = _T("");
	m_fScreensaverRandom = FALSE;
	m_fScreensaverMute = FALSE;
	//}}AFX_DATA_INIT
}

CSettingsScreensaverPropertyPage::~CSettingsScreensaverPropertyPage()
{
}

void CSettingsScreensaverPropertyPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsScreensaverPropertyPage)
	DDX_Text(pDX, IDC_EDIT_SCREENSAVER_PLAYLIST_FILE, m_szScreensaverPlaylistFile);
	DDX_Check(pDX, IDC_CHECK_SCREENSAVER_PLAYLIST_RANDOM, m_fScreensaverRandom);
	DDX_Check(pDX, IDC_CHECK_SCREENSAVER_PLAYLIST_MUTE, m_fScreensaverMute);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsScreensaverPropertyPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSettingsScreensaverPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON_SCREENSAVER_BROWSE, OnButtonScreensaverBrowse)
	ON_EN_CHANGE(IDC_EDIT_SCREENSAVER_PLAYLIST_FILE, OnChangeEditScreensaverPlaylistFile)
	ON_BN_CLICKED(IDC_BUTTON_SCREENSAVER_INSTALL, OnButtonScreensaverInstall)
	ON_BN_CLICKED(IDC_CHECK_SCREENSAVER_PLAYLIST_RANDOM, OnCheckScreensaverPlaylistRandom)
	ON_BN_CLICKED(IDC_CHECK_SCREENSAVER_PLAYLIST_MUTE, OnCheckScreensaverPlaylistMute)
//	ON_BN_CLICKED(IDC_BUTTON_SCREENSAVER_TEST, OnButtonScreensaverTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsScreensaverPropertyPage message handlers

BOOL CSettingsScreensaverPropertyPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		m_szScreensaverPlaylistFile = pMainFrame->m_SettingsTemp.m_szScreensaverPlaylistFile = pMainFrame->m_SettingsCurrent.m_szScreensaverPlaylistFile;
		m_fScreensaverRandom = pMainFrame->m_SettingsTemp.m_fScreensaverRandom = pMainFrame->m_SettingsCurrent.m_fScreensaverRandom;
		m_fScreensaverMute = pMainFrame->m_SettingsTemp.m_fScreensaverMute = pMainFrame->m_SettingsCurrent.m_fScreensaverMute;

		UpdateData(FALSE);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsScreensaverPropertyPage::OnButtonScreensaverBrowse() 
{
	CString szFilter;
	szFilter.LoadString(IDS_STRING_OPENPLAYLIST_FILTER);

	CFileDialog FileDialog(TRUE, _T("*.txt"), NULL,
		OFN_HIDEREADONLY | OFN_EXPLORER | OFN_ENABLESIZING,
		szFilter, this);
	
	if(FileDialog.DoModal() == IDOK)
	{
		CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
		if(pMainFrame)
		{
			pMainFrame->m_SettingsTemp.m_fScreensaverDirty = TRUE;
			pMainFrame->m_SettingsTemp.m_szScreensaverPlaylistFile = m_szScreensaverPlaylistFile = FileDialog.GetPathName();
			UpdateData(FALSE);
		}
	}
}

void CSettingsScreensaverPropertyPage::OnChangeEditScreensaverPlaylistFile() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		UpdateData();
		pMainFrame->m_SettingsTemp.m_fScreensaverDirty = TRUE;
		pMainFrame->m_SettingsTemp.m_szScreensaverPlaylistFile = m_szScreensaverPlaylistFile;
	}
}

void CSettingsScreensaverPropertyPage::OnButtonScreensaverInstall() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		UpdateData();
		pMainFrame->m_SettingsTemp.m_fScreensaverDirty = TRUE;

		AfxGetApp()->WriteProfileInt(INI_SETTINGS_GENERAL, _T("ScreensaverInstall"), pMainFrame->m_SettingsTemp.m_fScreensaverInstall);
		AfxGetApp()->WriteProfileString(INI_SETTINGS_GENERAL, _T("ScreensaverPlaylistFile"), pMainFrame->m_SettingsTemp.m_szScreensaverPlaylistFile);
		AfxGetApp()->WriteProfileInt(INI_SETTINGS_GENERAL, _T("ScreensaverMute"), pMainFrame->m_SettingsTemp.m_fScreensaverMute);
		AfxGetApp()->WriteProfileInt(INI_SETTINGS_GENERAL, _T("ScreensaverRandom"), pMainFrame->m_SettingsTemp.m_fScreensaverRandom);

		// Install the screensaver
		CString szExecutableName = AfxGetExecutableName();
		int nPos = szExecutableName.ReverseFind(_T('.'));
		CString szScreensaverName = szExecutableName.Left(nPos);
		szScreensaverName += _T(".scr");

		CopyFile(szExecutableName, szScreensaverName, FALSE);

		CString szParameters = _T("desk.cpl,InstallScreenSaver ");
		szParameters += szScreensaverName;
		ShellExecute(m_hWnd, _T("open"), _T("rundll32.exe"), szParameters, NULL, SW_SHOW);
	}
}
/*
void CSettingsScreensaverPropertyPage::OnButtonScreensaverTest() 
{
	CString szScreensaverName;
	HKEY hk;
	if(!RegCreateKey(HKEY_CURRENT_USER, _T("Control Panel\\Desktop"), &hk))
	{
		UCHAR pszBuf[512]; 
		DWORD ccBuf = sizeof(pszBuf);
		DWORD dwType = REG_SZ;
		if(RegQueryValueEx(hk, _T("SCRNSAVE.EXE"), 0, &dwType, pszBuf, &ccBuf) == ERROR_SUCCESS)
		{
			szScreensaverName = pszBuf;
		}
		RegCloseKey(hk);
	}

	if(szScreensaverName != _T(""))
	{
		Sleep(200);
		ShellExecute(m_hWnd, _T("open"), szScreensaverName, _T("/s"), NULL, SW_SHOW);
	}
}
*/
void CSettingsScreensaverPropertyPage::OnCheckScreensaverPlaylistRandom() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		UpdateData();
		pMainFrame->m_SettingsTemp.m_fScreensaverDirty = TRUE;
		pMainFrame->m_SettingsTemp.m_fScreensaverRandom = m_fScreensaverRandom;
	}
}

void CSettingsScreensaverPropertyPage::OnCheckScreensaverPlaylistMute() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		UpdateData();
		pMainFrame->m_SettingsTemp.m_fScreensaverDirty = TRUE;
		pMainFrame->m_SettingsTemp.m_fScreensaverMute = m_fScreensaverMute;
	}
}
