//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// SettingsSubtitlePropertyPage.cpp : implementation file
//

#include "stdafx.h"
#include "mplayerx.h"
#include "SettingsSubtitlePropertyPage.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsSubtitlePropertyPage property page

IMPLEMENT_DYNCREATE(CSettingsSubtitlePropertyPage, CPropertyPage)

CSettingsSubtitlePropertyPage::CSettingsSubtitlePropertyPage() : CPropertyPage(CSettingsSubtitlePropertyPage::IDD)
{
	//{{AFX_DATA_INIT(CSettingsSubtitlePropertyPage)
	m_nPosY = 0;
	m_fTransparent = FALSE;
	//}}AFX_DATA_INIT

	m_fDialogInitialized = FALSE;
}

CSettingsSubtitlePropertyPage::~CSettingsSubtitlePropertyPage()
{
}

void CSettingsSubtitlePropertyPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsSubtitlePropertyPage)
	DDX_Control(pDX, IDC_STATIC_SAMPLE, m_wndStatic);
	DDX_Control(pDX, IDC_SPIN_POS_Y, m_wndSpinPosY);
	DDX_Check(pDX, IDC_CHECK_TRANSPARENT, m_fTransparent);
	DDX_Text(pDX, IDC_EDIT_POS_Y, m_nPosY);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsSubtitlePropertyPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSettingsSubtitlePropertyPage)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_FONT, OnButtonSelectFont)
	ON_BN_CLICKED(IDC_BUTTON_BACKGROUND_COLOR, OnButtonBackgroundColor)
	ON_BN_CLICKED(IDC_CHECK_TRANSPARENT, OnCheckTransparent)
	ON_EN_CHANGE(IDC_EDIT_POS_Y, OnChangeEditPosY)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsSubtitlePropertyPage message handlers

BOOL CSettingsSubtitlePropertyPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		LOGFONT lf;
		pMainFrame->m_SettingsCurrent.m_fontSubtitle.GetLogFont(&lf);
		if(pMainFrame->m_SettingsTemp.m_fontSubtitle.m_hObject)
			pMainFrame->m_SettingsTemp.m_fontSubtitle.DeleteObject();
		lf.lfQuality |= ANTIALIASED_QUALITY; // | CLEARTYPE_QUALITY;
		pMainFrame->m_SettingsTemp.m_fontSubtitle.CreateFontIndirect(&lf);
		pMainFrame->m_SettingsTemp.m_colorSubtitleFont = pMainFrame->m_SettingsCurrent.m_colorSubtitleFont;
		pMainFrame->m_SettingsTemp.m_colorSubtitleBackgroundFont = pMainFrame->m_SettingsCurrent.m_colorSubtitleBackgroundFont;
		m_fTransparent = pMainFrame->m_SettingsTemp.m_fSubtitleTransparent = pMainFrame->m_SettingsCurrent.m_fSubtitleTransparent;

		m_nPosY = pMainFrame->m_SettingsTemp.m_nSubtitlePosY = pMainFrame->m_SettingsCurrent.m_nSubtitlePosY;

		m_wndStatic.SetFont(&pMainFrame->m_SettingsTemp.m_fontSubtitle);
		m_wndStatic.m_colorFont = pMainFrame->m_SettingsTemp.m_colorSubtitleFont;
		m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorSubtitleBackgroundFont;
		m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fSubtitleTransparent;

		m_nPosY = pMainFrame->m_SettingsTemp.m_nSubtitlePosY = pMainFrame->m_SettingsCurrent.m_nSubtitlePosY;
	}

	m_wndSpinPosY.SetPos(m_nPosY);
	m_wndSpinPosY.SetRange32(-999, 999);

	m_fDialogInitialized = TRUE;
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsSubtitlePropertyPage::OnButtonSelectFont() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		LOGFONT logfont;
		pMainFrame->m_SettingsTemp.m_fontSubtitle.GetLogFont(&logfont);
		CFontDialog dlg(&logfont, CF_EFFECTS | CF_SCREENFONTS, NULL, this);
		dlg.m_cf.rgbColors = pMainFrame->m_SettingsTemp.m_colorSubtitleFont;
		if(dlg.DoModal() == IDOK)
		{
			pMainFrame->m_SettingsTemp.m_fontSubtitle.DeleteObject();
			logfont.lfQuality |= ANTIALIASED_QUALITY; // | CLEARTYPE_QUALITY;
			pMainFrame->m_SettingsTemp.m_fontSubtitle.CreateFontIndirect(&logfont);
			pMainFrame->m_SettingsTemp.m_colorSubtitleFont = dlg.GetColor();

			m_wndStatic.SetFont(&pMainFrame->m_SettingsTemp.m_fontSubtitle);
			m_wndStatic.m_colorFont = pMainFrame->m_SettingsTemp.m_colorSubtitleFont;
			m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorSubtitleFont;
			m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fSubtitleTransparent;

			pMainFrame->m_SettingsTemp.m_fSubtitleDirty = TRUE;

			Invalidate();
		}
	}
}

void CSettingsSubtitlePropertyPage::OnButtonBackgroundColor() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		CColorDialog dlg(pMainFrame->m_SettingsTemp.m_colorSubtitleBackgroundFont, CC_FULLOPEN); //CC_RGBINIT);
		if(dlg.DoModal() == IDOK)
		{
			m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorSubtitleBackgroundFont = dlg.GetColor();
			pMainFrame->m_SettingsTemp.m_fSubtitleDirty = TRUE;

			Invalidate();
		}
	}
}

void CSettingsSubtitlePropertyPage::OnCheckTransparent() 
{
	UpdateData();
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fSubtitleTransparent = m_fTransparent;
		pMainFrame->m_SettingsTemp.m_fSubtitleDirty = TRUE;

		Invalidate();
	}
}

void CSettingsSubtitlePropertyPage::OnChangeEditPosY()
{
	if(!m_fDialogInitialized)
		return;
	UpdateData();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		pMainFrame->m_SettingsTemp.m_nSubtitlePosY = m_nPosY;
		pMainFrame->m_SettingsTemp.m_fSubtitleDirty = TRUE;
	}
}
