//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// SettingsTimeLinePropertyPage.cpp : implementation file
//

#include "stdafx.h"
#include "mplayerx.h"
#include "SettingsTimeLinePropertyPage.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSettingsTimeLinePropertyPage property page

IMPLEMENT_DYNCREATE(CSettingsTimeLinePropertyPage, CPropertyPage)

CSettingsTimeLinePropertyPage::CSettingsTimeLinePropertyPage() : CPropertyPage(CSettingsTimeLinePropertyPage::IDD)
{
	//{{AFX_DATA_INIT(CSettingsTimeLinePropertyPage)
	m_nPosY = 0;
	m_fTransparent = FALSE;
	//}}AFX_DATA_INIT

	m_fDialogInitialized = FALSE;
}

CSettingsTimeLinePropertyPage::~CSettingsTimeLinePropertyPage()
{
}

void CSettingsTimeLinePropertyPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSettingsTimeLinePropertyPage)
	DDX_Control(pDX, IDC_STATIC_SAMPLE, m_wndStatic);
	DDX_Control(pDX, IDC_SPIN_POS_Y, m_wndSpinPosY);
	DDX_Check(pDX, IDC_CHECK_TRANSPARENT, m_fTransparent);
	DDX_Text(pDX, IDC_EDIT_POS_Y, m_nPosY);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSettingsTimeLinePropertyPage, CPropertyPage)
	//{{AFX_MSG_MAP(CSettingsTimeLinePropertyPage)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_FONT, OnButtonSelectFont)
	ON_BN_CLICKED(IDC_BUTTON_BACKGROUND_COLOR, OnButtonBackgroundColor)
	ON_BN_CLICKED(IDC_CHECK_TRANSPARENT, OnCheckTransparent)
	ON_EN_CHANGE(IDC_EDIT_POS_Y, OnChangeEditPosY)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsTimeLinePropertyPage message handlers

BOOL CSettingsTimeLinePropertyPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		LOGFONT lf;
		pMainFrame->m_SettingsCurrent.m_fontTimeLine.GetLogFont(&lf);
		if(pMainFrame->m_SettingsTemp.m_fontTimeLine.m_hObject)
			pMainFrame->m_SettingsTemp.m_fontTimeLine.DeleteObject();
		lf.lfQuality |= ANTIALIASED_QUALITY; // | CLEARTYPE_QUALITY;
		pMainFrame->m_SettingsTemp.m_fontTimeLine.CreateFontIndirect(&lf);
		pMainFrame->m_SettingsTemp.m_colorTimeLineFont = pMainFrame->m_SettingsCurrent.m_colorTimeLineFont;
		pMainFrame->m_SettingsTemp.m_colorTimeLineBackgroundFont = pMainFrame->m_SettingsCurrent.m_colorTimeLineBackgroundFont;
		m_fTransparent = pMainFrame->m_SettingsTemp.m_fTimeLineTransparent = pMainFrame->m_SettingsCurrent.m_fTimeLineTransparent;

		m_nPosY = pMainFrame->m_SettingsTemp.m_nTimeLinePosY = pMainFrame->m_SettingsCurrent.m_nTimeLinePosY;

		m_wndStatic.SetFont(&pMainFrame->m_SettingsTemp.m_fontTimeLine);
		m_wndStatic.m_colorFont = pMainFrame->m_SettingsTemp.m_colorTimeLineFont;
		m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorTimeLineBackgroundFont;
		m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fTimeLineTransparent;

		m_nPosY = pMainFrame->m_SettingsTemp.m_nTimeLinePosY = pMainFrame->m_SettingsCurrent.m_nTimeLinePosY;
	}

	m_wndSpinPosY.SetPos(m_nPosY);
	m_wndSpinPosY.SetRange32(-999, 999);

	m_fDialogInitialized = TRUE;
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsTimeLinePropertyPage::OnButtonSelectFont() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		LOGFONT logfont;
		pMainFrame->m_SettingsTemp.m_fontTimeLine.GetLogFont(&logfont);
		CFontDialog dlg(&logfont, CF_EFFECTS | CF_SCREENFONTS, NULL, this);
		dlg.m_cf.rgbColors = pMainFrame->m_SettingsTemp.m_colorTimeLineFont;
		if(dlg.DoModal() == IDOK)
		{
			pMainFrame->m_SettingsTemp.m_fontTimeLine.DeleteObject();
			logfont.lfQuality |= ANTIALIASED_QUALITY; // | CLEARTYPE_QUALITY;
			pMainFrame->m_SettingsTemp.m_fontTimeLine.CreateFontIndirect(&logfont);
			pMainFrame->m_SettingsTemp.m_colorTimeLineFont = dlg.GetColor();

			m_wndStatic.SetFont(&pMainFrame->m_SettingsTemp.m_fontTimeLine);
			m_wndStatic.m_colorFont = pMainFrame->m_SettingsTemp.m_colorTimeLineFont;
			m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorTimeLineFont;
			m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fTimeLineTransparent;

			pMainFrame->m_SettingsTemp.m_fTimeLineDirty = TRUE;

			Invalidate();
		}
	}
}

void CSettingsTimeLinePropertyPage::OnButtonBackgroundColor() 
{
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		CColorDialog dlg(pMainFrame->m_SettingsTemp.m_colorTimeLineBackgroundFont, CC_FULLOPEN); //CC_RGBINIT);
		if(dlg.DoModal() == IDOK)
		{
			m_wndStatic.m_colorBackgroundFont = pMainFrame->m_SettingsTemp.m_colorTimeLineBackgroundFont = dlg.GetColor();
			pMainFrame->m_SettingsTemp.m_fTimeLineDirty = TRUE;

			Invalidate();
		}
	}
}

void CSettingsTimeLinePropertyPage::OnCheckTransparent() 
{
	UpdateData();
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		m_wndStatic.m_fTransparent = pMainFrame->m_SettingsTemp.m_fTimeLineTransparent = m_fTransparent;
		pMainFrame->m_SettingsTemp.m_fTimeLineDirty = TRUE;

		Invalidate();
	}
}

void CSettingsTimeLinePropertyPage::OnChangeEditPosY()
{
	if(!m_fDialogInitialized)
		return;
	UpdateData();
	
	CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
	if(pMainFrame)
	{
		pMainFrame->m_SettingsTemp.m_nTimeLinePosY = m_nPosY;
		pMainFrame->m_SettingsTemp.m_fTimeLineDirty = TRUE;
	}
}
