//    MPlayerX - Multimedia file player application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

//
// SubtitleDialogBar.cpp : implementation file
//

#include "stdafx.h"
#include "MPlayerX.h"
#include "SubtitleDialogBar.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSubtitleDialogBar

CSubtitleDialogBar::CSubtitleDialogBar()
{
}

CSubtitleDialogBar::~CSubtitleDialogBar()
{
}


BEGIN_MESSAGE_MAP(CSubtitleDialogBar, CSizingControlBarG)
	//{{AFX_MSG_MAP(CSubtitleDialogBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_CBN_SELCHANGE(IDC_COMBOBOX_SUBTITLE, OnSelchangeComboSubtitle)
	ON_EN_CHANGE(IDC_EDIT_DELAY, OnChangeEditDelay)
	ON_CBN_SELCHANGE(IDC_COMBOBOX_FRAME_RATE, OnSelchangeComboFrameRate)
	ON_CBN_EDITCHANGE(IDC_COMBOBOX_FRAME_RATE, OnEditchangeComboFrameRate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSubtitleDialogBar message handlers

int CSubtitleDialogBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CSizingControlBarG::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if(!m_wndComboBoxSubtitle.Create(WS_CHILD | WS_VISIBLE | WS_VSCROLL | CBS_DROPDOWNLIST,
			CRect(0, 0, 0, 0), this, IDC_COMBOBOX_SUBTITLE))
		return -1;

	if(!m_wndEditDelay.Create(WS_CHILD | WS_VISIBLE,
			CRect(0, 0, 0, 0), this, IDC_EDIT_DELAY))
		return -1;

	if(!m_wndComboBoxFrameRate.Create(WS_CHILD | WS_VISIBLE | CBS_DROPDOWN | CBS_AUTOHSCROLL,
			CRect(0, 0, 0, 0), this, IDC_COMBOBOX_FRAME_RATE))
		return -1;

	CString szText;
	szText.LoadString(IDS_DIALOGBAR_SUBTITLE_SUBTITLE);
	if(!m_wndStaticSubtitle.Create(szText, WS_CHILD | WS_VISIBLE,
			CRect(0, 0, 0, 0), this))
		return -1;

	szText.LoadString(IDS_DIALOGBAR_SUBTITLE_DELAY);
	if(!m_wndStaticDelay.Create(szText, WS_CHILD | WS_VISIBLE,
			CRect(0, 0, 0, 0), this))
		return -1;

	szText.LoadString(IDS_DIALOGBAR_SUBTITLE_FRAME_RATE);
	if(!m_wndStaticFrameRate.Create(szText, WS_CHILD | WS_VISIBLE,
			CRect(0, 0, 0, 0), this))
		return -1;

	m_wndComboBoxSubtitle.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));
	m_wndEditDelay.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));
	m_wndComboBoxFrameRate.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));
	m_wndStaticSubtitle.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));
	m_wndStaticDelay.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));
	m_wndStaticFrameRate.SetFont(CFont::FromHandle((HFONT)::GetStockObject(DEFAULT_GUI_FONT)));

	m_wndComboBoxFrameRate.AddString(_T("23.97"));
	m_wndComboBoxFrameRate.AddString(_T("23.976"));
	m_wndComboBoxFrameRate.AddString(_T("25"));
	m_wndComboBoxFrameRate.AddString(_T("29.97"));

	Clear();

	return 0;
}

void CSubtitleDialogBar::Clear()
{
	m_wndComboBoxSubtitle.ResetContent();
	CString szString;
	szString.LoadString(IDS_STRING_SUBTITLE_BAR_NO_SUBTITLE);
	int nIndex = m_wndComboBoxSubtitle.AddString(szString);
	if(nIndex != CB_ERR)
	{
		m_wndComboBoxSubtitle.SetItemData(nIndex, -1);
		m_wndComboBoxSubtitle.SetCurSel(nIndex);
	}

	m_wndEditDelay.SetWindowText(_T("0.000"));
	m_wndEditDelay.EnableWindow(FALSE);

	m_wndComboBoxFrameRate.SetWindowText(_T(""));
	m_wndComboBoxFrameRate.EnableWindow(FALSE);
}

void CSubtitleDialogBar::OnSize(UINT nType, int cx, int cy) 
{
	CSizingControlBarG::OnSize(nType, cx, cy);
	
	m_wndStaticSubtitle.MoveWindow(5, 0, cx - 10, 15);
	m_wndComboBoxSubtitle.MoveWindow(5, 15, cx - 10, 150);

	m_wndStaticDelay.MoveWindow(5, 45, cx - 10, 16);
	m_wndEditDelay.MoveWindow(5, 60, cx - 10, 16);

	m_wndStaticFrameRate.MoveWindow(5, 90, cx - 10, 15);
	m_wndComboBoxFrameRate.MoveWindow(5, 105, cx - 10, 150);
}

void CSubtitleDialogBar::OnSelchangeComboSubtitle() 
{
	int nSelection = m_wndComboBoxSubtitle.GetCurSel();
	if(nSelection != CB_ERR)
	{
		int nSubtitleIndex = m_wndComboBoxSubtitle.GetItemData(nSelection);
		CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
		if(pMainFrame)
		{
			CSubtitle * pSubtitle = pMainFrame->m_SubtitleManager.Select(nSubtitleIndex);
			m_wndEditDelay.EnableWindow(pSubtitle != NULL);
			m_wndComboBoxFrameRate.EnableWindow(pSubtitle != NULL);
			if(pSubtitle)
			{
				CString szDelay;
				szDelay.Format(_T("%f"), pSubtitle->GetDelay());
				m_wndEditDelay.SetWindowText(szDelay);

				BOOL bTimeBased = pSubtitle->GetTimeBased();
				m_wndComboBoxFrameRate.EnableWindow(!bTimeBased);
				if(!bTimeBased)
					m_wndComboBoxFrameRate.SetWindowText(_T(""));

				CString szFrameRate;
				int nFrameRateCount = m_wndComboBoxFrameRate.GetCount();
				double dFrameRate = pSubtitle->GetFramePerSecond();
				for(int nIndex = 0; nIndex < nFrameRateCount; nIndex++)
				{
					m_wndComboBoxFrameRate.GetLBText(nIndex, szFrameRate);
					if(dFrameRate == atof(szFrameRate))
					{
						m_wndComboBoxFrameRate.SetCurSel(nIndex);
						break;
					}
				}
				if(nIndex == nFrameRateCount)
				{
					szFrameRate.Format(_T("%f"), dFrameRate);
					m_wndComboBoxFrameRate.SetWindowText(szFrameRate);
				}
/*				szFrameRate.Format(_T("%f"), pSubtitle->GetFramePerSecond());
				int nIndex = m_wndComboBoxFrameRate.FindString(0, szFrameRate);
				if(nIndex != CB_ERR)
					m_wndComboBoxFrameRate.SetCurSel(nIndex);
				else
					m_wndComboBoxFrameRate.SetWindowText(szFrameRate);
*/
			}
		}
	}
}

void CSubtitleDialogBar::OnChangeEditDelay() 
{
	int nSelection = m_wndComboBoxSubtitle.GetCurSel();
	if(nSelection != CB_ERR)
	{
		int nSubtitleIndex = m_wndComboBoxSubtitle.GetItemData(nSelection);
		CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
		if(pMainFrame)
		{
			CSubtitle * pSubtitle = pMainFrame->m_SubtitleManager.GetSubtitle(nSubtitleIndex);
			if(pSubtitle)
			{
				CString szDelay;
				m_wndEditDelay.GetWindowText(szDelay);
				pSubtitle->SetDelay(atof(szDelay));
			}
		}
	}
}

void CSubtitleDialogBar::OnSelchangeComboFrameRate() 
{
	int nSelection = m_wndComboBoxSubtitle.GetCurSel();
	if(nSelection != CB_ERR)
	{
		int nSubtitleIndex = m_wndComboBoxSubtitle.GetItemData(nSelection);
		CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
		if(pMainFrame)
		{
			CSubtitle * pSubtitle = pMainFrame->m_SubtitleManager.GetSubtitle(nSubtitleIndex);
			if(pSubtitle)
			{
				int nFrameRateSelection = m_wndComboBoxFrameRate.GetCurSel();
				if(nFrameRateSelection != CB_ERR)
				{
					CString szFrameRate;
					m_wndComboBoxFrameRate.GetLBText(nFrameRateSelection, szFrameRate);
					pSubtitle->SetFramePerSecond(atof(szFrameRate));
				}
			}
		}
	}
}

void CSubtitleDialogBar::OnEditchangeComboFrameRate() 
{
	int nSelection = m_wndComboBoxSubtitle.GetCurSel();
	if(nSelection != CB_ERR)
	{
		int nSubtitleIndex = m_wndComboBoxSubtitle.GetItemData(nSelection);
		CMainFrame * pMainFrame = (CMainFrame *)AfxGetMainWnd();
		if(pMainFrame)
		{
			CSubtitle * pSubtitle = pMainFrame->m_SubtitleManager.GetSubtitle(nSubtitleIndex);
			if(pSubtitle)
			{
				CString szFrameRate;
				m_wndComboBoxFrameRate.GetWindowText(szFrameRate);
				pSubtitle->SetFramePerSecond(atof(szFrameRate));
			}
		}
	}
}

BOOL CSubtitleDialogBar::PreTranslateMessage(MSG* pMsg) 
{
    if (pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST)
    {
        // dipatch keyboard messages directly (skip main accelerators)
        ::TranslateMessage(pMsg);
        ::DispatchMessage(pMsg);
        return TRUE;
    }
	
	return CSizingControlBarG::PreTranslateMessage(pMsg);
}
