//    NetExplorer - Windows LAN explorer application
//    Copyright (C) 2002  Regis COSNIER
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

// StringEx.h: interface for the CStringEx class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STRINGEX_H__INCLUDED_)
#define AFX_STRINGEX_H__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CStringEx : public CString  
{
public:
        CStringEx() : CString( ){};
        CStringEx( const CString& stringSrc) : CString( stringSrc ){};
        CStringEx( const CStringEx& stringSrc) : CString( stringSrc ){};
        CStringEx( TCHAR ch, int nRepeat = 1 ) : CString( ch, nRepeat ){};
        CStringEx( LPCTSTR lpch, int nLength ) : CString( lpch, nLength ){};
        CStringEx( const unsigned char* psz ) : CString( psz ){};
        CStringEx( LPCWSTR lpsz ) : CString( lpsz ){};
        CStringEx( LPCSTR lpsz ) : CString( lpsz ){};

        CStringEx& Insert(int pos, LPCTSTR s);
        CStringEx& Insert(int pos, TCHAR c);

        CStringEx& Delete(int pos, int len);
        CStringEx& Replace(int pos, int len, LPCTSTR s);

        int Find( TCHAR ch, int startpos = 0 ) const;
        int Find( LPCTSTR lpszSub, int startpos = 0 ) const;
        int FindNoCase( TCHAR ch, int startpos = 0 ) const;
        int FindNoCase( LPCTSTR lpszSub, int startpos = 0 ) const;

        int FindReplace( LPCTSTR lpszSub, LPCTSTR lpszReplaceWith, BOOL bGlobal = TRUE );
        int FindReplaceNoCase( LPCTSTR lpszSub, LPCTSTR lpszReplaceWith, 
                                BOOL bGlobal = TRUE );

        int ReverseFind( TCHAR ch ) const{ return CString::ReverseFind(ch);};
        int ReverseFind( LPCTSTR lpszSub, int startpos = -1 ) const;
        int ReverseFindNoCase( TCHAR ch, int startpos = -1  ) const;
        int ReverseFindNoCase( LPCTSTR lpszSub, int startpos = -1 ) const;

        CStringEx GetField( LPCTSTR delim, int fieldnum);
        CStringEx GetField( TCHAR delim, int fieldnum);
        int GetFieldCount( LPCTSTR delim );
        int GetFieldCount( TCHAR delim );

        CStringEx GetDelimitedField( LPCTSTR delimStart, LPCTSTR delimEnd, 
                                int fieldnum = 0);
};

#endif // !defined(AFX_STRINGEX_H__INCLUDED_)
