//
// Extracted from XP headers, so that
// we can build with dx8.0

#ifndef __IVMRFilterConfig_INTERFACE_DEFINED__
#define __IVMRFilterConfig_INTERFACE_DEFINED__

#pragma once


class IVMRImageCompositor;
      
MIDL_INTERFACE("9e5530c5-7034-48b4-bb46-0b8a6efc8e36") IVMRFilterConfig;
DECLARE_INTERFACE_(IVMRFilterConfig, IUnknown)
{
    STDMETHOD(SetImageCompositor)(THIS_
        /* [in] */ IVMRImageCompositor *lpVMRImgCompositor) PURE;
    
    STDMETHOD(SetNumberOfStreams)(THIS_
        /* [in] */ DWORD dwMaxStreams) PURE;
    
    STDMETHOD(GetNumberOfStreams)(THIS_
        /* [out] */ DWORD *pdwMaxStreams) PURE;
    
    STDMETHOD(SetRenderingPrefs)(THIS_
        /* [in] */ DWORD dwRenderFlags) PURE;
    
    STDMETHOD(GetRenderingPrefs)(THIS_
        /* [out] */ DWORD *pdwRenderFlags) PURE;
    
    STDMETHOD(SetRenderingMode)(THIS_
        /* [in] */ DWORD Mode) PURE;
    
    STDMETHOD(GetRenderingMode)(THIS_
        /* [out] */ DWORD *pMode) PURE;
};

MIDL_INTERFACE("a9849bbe-9ec8-4263-b764-62730f0d15d0") IVMRSurface;
DECLARE_INTERFACE_(IVMRSurface, IUnknown)
{
    STDMETHOD(IsSurfaceLocked)(THIS) PURE;
    
    STDMETHOD(LockSurface)(THIS_
        /* [out] */ BYTE **lpSurface) PURE;
    
    STDMETHOD(UnlockSurface)(THIS) PURE;
    
    STDMETHOD(GetSurface)(THIS_
        /* [out] */ LPDIRECTDRAWSURFACE7 *lplpSurface) PURE;
};

MIDL_INTERFACE("058d1f11-2a54-4bef-bd54-df706626b727") IVMRVideoStreamControl;
DECLARE_INTERFACE_(IVMRVideoStreamControl, IUnknown)
{
    STDMETHOD(SetColorKey)(THIS_ 
        /* [in] */ LPDDCOLORKEY lpClrKey) PURE;
    
    STDMETHOD(GetColorKey)(THIS_ 
        /* [out] */ LPDDCOLORKEY lpClrKey) PURE;
    
    STDMETHOD(SetStreamActiveState)(THIS_ 
        /* [in] */ BOOL fActive) PURE;
    
    STDMETHOD(GetStreamActiveState)(THIS_ 
        /* [out] */ BOOL *lpfActive) PURE;
    
};
    
typedef struct _NORMALIZEDRECT
    {
    float left;
    float top;
    float right;
    float bottom;
    } 	NORMALIZEDRECT;

MIDL_INTERFACE("1c1a17b0-bed0-415d-974b-dc6696131599") IVMRMixerControl;
DECLARE_INTERFACE_(IVMRMixerControl, IUnknown)
{
    STDMETHOD(SetAlpha)(THIS_ 
        /* [in] */ DWORD dwStreamID,
        /* [in] */ float Alpha) PURE;
    
    STDMETHOD(GetAlpha)(THIS_ 
        /* [in] */ DWORD dwStreamID,
        /* [out] */ float *pAlpha) PURE;
    
    STDMETHOD(SetZOrder)(THIS_ 
        /* [in] */ DWORD dwStreamID,
        /* [in] */ DWORD dwZ) PURE;
    
    STDMETHOD(GetZOrder)(THIS_ 
        /* [in] */ DWORD dwStreamID,
        /* [out] */ DWORD *pZ) PURE;
    
    STDMETHOD(SetOutputRect)(THIS_ 
        /* [in] */ DWORD dwStreamID,
        /* [in] */ const NORMALIZEDRECT *pRect) PURE;
    
    STDMETHOD(GetOutputRect)(THIS_ 
        /* [in] */ DWORD dwStreamID,
        /* [out] */ NORMALIZEDRECT *pRect) PURE;
    
    STDMETHOD(SetBackgroundClr)(THIS_ 
        /* [in] */ COLORREF ClrBkg) PURE;
    
    STDMETHOD(GetBackgroundClr)(THIS_ 
        /* [in] */ COLORREF *lpClrBkg) PURE;
    
    STDMETHOD(SetMixingPrefs)(THIS_ 
        /* [in] */ DWORD dwMixerPrefs) PURE;
    
    STDMETHOD(GetMixingPrefs)(THIS_ 
        /* [out] */ DWORD *pdwMixerPrefs) PURE;
    
};


typedef struct _VMRALPHABITMAP
    {
    DWORD dwFlags;
    HDC hdc;
    LPDIRECTDRAWSURFACE7 pDDS;
    RECT rSrc;
    NORMALIZEDRECT rDest;
    FLOAT fAlpha;
    COLORREF clrSrcKey;
    }   VMRALPHABITMAP;

typedef struct _VMRALPHABITMAP *PVMRALPHABITMAP;

#define VMRBITMAP_DISABLE            0x00000001
#define VMRBITMAP_HDC                0x00000002
#define VMRBITMAP_ENTIREDDS          0x00000004
#define VMRBITMAP_SRCCOLORKEY        0x00000008
#define VMRBITMAP_SRCRECT            0x00000010


MIDL_INTERFACE("1E673275-0257-40aa-AF20-7C608D4A0428") IVMRMixerBitmap;
DECLARE_INTERFACE_(IVMRMixerBitmap, IUnknown)
{
    STDMETHOD(SetAlphaBitmap)(THIS_ 
        /* [in] */ const VMRALPHABITMAP *pBmpParms) PURE;

    STDMETHOD(UpdateAlphaBitmapParameters)(THIS_ 
        /* [in] */ PVMRALPHABITMAP pBmpParms) PURE;

    STDMETHOD(GetAlphaBitmapParameters)(THIS_ 
        /* [out] */ PVMRALPHABITMAP pBmpParms) PURE;
};

typedef enum __MIDL___MIDL_itf_strmif_0385_0001
    {   MixerPref_NoDecimation  = 0x1,
        MixerPref_DecimateOutput        = 0x2,
        MixerPref_DecimateMask  = 0xf,
        MixerPref_BiLinearFiltering     = 0x10,
        MixerPref_PointFiltering        = 0x20,
        MixerPref_FilteringMask = 0xf0,
        MixerPref_RenderTargetRGB       = 0x100,
        MixerPref_RenderTargetYUV420    = 0x200,
        MixerPref_RenderTargetYUV422    = 0x400,
        MixerPref_RenderTargetYUV444    = 0x800,
        MixerPref_RenderTargetReserved  = 0xf000,
        MixerPref_RenderTargetMask      = 0xff00
    }   VMRMixerPrefs;


#endif

